//
//  runTileMapAppDelegate.cpp
//  runTileMap
//
//  Created by Mac on 14-8-14.
//  Copyright __MyCompanyName__ 2014年. All rights reserved.
//

#include "AppDelegate.h"

#include "cocos2d.h"
#include "SimpleAudioEngine.h"
#include "MainScene.h"

USING_NS_CC;
using namespace CocosDenshion;

const float DESIGN_WIDTH = 1280;	// 960
const float DESIGN_HEIGHT = 720;	// 640
const float DESIGN_LO_HEIGHT = 320;	// 640

AppDelegate::AppDelegate()
{

}

AppDelegate::~AppDelegate()
{
}

bool AppDelegate::applicationDidFinishLaunching()
{
    // initialize director
    CCDirector *pDirector = CCDirector::sharedDirector();
    pDirector->setOpenGLView(CCEGLView::sharedOpenGLView());

    CCSize screenSize = CCEGLView::sharedOpenGLView()->getFrameSize();
    CCSize designSize = CCSizeMake(DESIGN_WIDTH, DESIGN_HEIGHT);
    std::vector<std::string> searchPaths;

    if (screenSize.height > DESIGN_LO_HEIGHT)
    {
    	searchPaths.push_back("hd");
    	searchPaths.push_back("sd");
    	pDirector->setContentScaleFactor(DESIGN_HEIGHT/designSize.height);
    }
    else
    {
    	searchPaths.push_back("sd");
    	pDirector->setContentScaleFactor(DESIGN_LO_HEIGHT/screenSize.height);
    }

    CCFileUtils::sharedFileUtils()->setSearchPaths(searchPaths);

    //CCLog("screen size: %f, %f, %f, %f", screenSize.width, screenSize.height, designSize.width, designSize.height);

    CCEGLView::sharedOpenGLView()->setDesignResolutionSize(designSize.width, designSize.height, kResolutionNoBorder);//kResolutionShowAll);//


    // turn on display FPS
    pDirector->setDisplayStats(false);

    // set FPS. the default value is 1.0/60 if you don't call this
    pDirector->setAnimationInterval(1.0 / 60);

    // create a scene. it's an autorelease object
//    CCScene *pScene = HelloWorld::scene();
    CCScene *pScene = CMainScene::scene();

    // run
    pDirector->runWithScene(pScene);

    return true;
}


// This function will be called when the app is inactive. When comes a phone call,it's be invoked too
void AppDelegate::applicationDidEnterBackground()
{
    CCDirector::sharedDirector()->stopAnimation();
    SimpleAudioEngine::sharedEngine()->pauseBackgroundMusic();
    SimpleAudioEngine::sharedEngine()->pauseAllEffects();
}

// this function will be called when the app is active again
void AppDelegate::applicationWillEnterForeground()
{
    CCDirector::sharedDirector()->startAnimation();
    SimpleAudioEngine::sharedEngine()->resumeBackgroundMusic();
    SimpleAudioEngine::sharedEngine()->resumeAllEffects();
}
