//
//  BuyGoldLayer.cpp
//  runTileMap
//
//  Created by Mac on 14-11-7.
//
//

#include "BuyGoldLayer.h"

#include "GameData.h"

#include "SoundManager.h"
#include "baseSDKController.h"

//#if (CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
//    #include "jsoncpp/Json.h"
//#else
//    #include "Json.h"
//#endif


CBuyGoldLayer::CBuyGoldLayer()
{
    
    
    pBGSprite = NULL;
    pTextSprite = NULL;
    pMenu = NULL;
}

CBuyGoldLayer::~CBuyGoldLayer()
{
    
}

bool CBuyGoldLayer::init()
{
    if (CCLayer::init( ) )
	{
        if (CGameData::getInstance()->getStoreVerion() == STORE_GOOGLEPLAY) {
            pBGSprite = CCSprite::create("buygold2item.png");
        }else if( CGameData::getInstance()->getStoreVerion() == STORE_GAME9)
        {
            pBGSprite = CCSprite::createWithSpriteFrameName("buylayer_bg.png");//3个item
        }
        
        
        pBGSprite->setAnchorPoint(CCPointZero);
        pBGSprite->setPosition(ccp(0, 0));
        addChild(pBGSprite);
        
//        pTextSprite = CCSprite::createWithSpriteFrameName("buylayer_text.png");
//        pTextSprite->setAnchorPoint(CCPointZero);
//        pTextSprite->setPosition(ccp(0, 0));
//        addChild(pTextSprite);
        
        CCLabelTTF * title = CCLabelTTF::create("Buy Coins", "STHeiti TC", 40);
        title->setAnchorPoint(ccp(0.5,0));
        pBGSprite -> addChild(title);
        
        title->setPosition(ccp(pBGSprite->getContentSize().width/2, pBGSprite->getContentSize().height-65));
        
        
        
        CCSpriteFrameCache* cache = CCSpriteFrameCache::sharedSpriteFrameCache();
        
        int itemX1 = 84;
        int itemX2 = 224;
        int itemX3 = 364;
        int itemGad = 144;
        int itemY1 = 185;
        int itemY2 = 118;
        int itemY3 = 46;
        
        if (CGameData::getInstance()->getStoreVerion() == STORE_GOOGLEPLAY) {
            itemX1 = 113;
            itemX2 = 320;
            
            itemY1 = 170;
        }
        
        
        
        //11111111
        
        CCSprite * goldIcon1 = CCSprite::createWithSpriteFrameName("gold_a.png");
        
        goldIcon1->setPosition(ccp(itemX1, itemY1));
        pBGSprite -> addChild(goldIcon1);
        
        
        std::vector<int> goldnumv =  CGameData::getInstance()->getBuyGoldNum();
        
        char  cgoldnum1[64] ={0};
        sprintf(cgoldnum1, "X%d",goldnumv[0]);
        CCLabelTTF * buyNumText1 = CCLabelTTF::create(cgoldnum1, "STHeiti TC", 25);
        buyNumText1->setColor(ccYELLOW);
        buyNumText1->setAnchorPoint(ccp(0,0));
        buyNumText1->setPosition(ccp(0, -30));
        goldIcon1 -> addChild(buyNumText1);
        
//        CCSprite * prires1 = CCSprite::createWithSpriteFrameName("goldnum_can.png");
//        prires1 -> setPosition(ccp(itemX1, itemY2));
//        pBGSprite -> addChild(prires1);
        
        buyPriseText1 = CCLabelTTF::create(CGameData::getInstance() -> strPrice1.c_str(), "STHeiti TC", 25);
        buyPriseText1->setAnchorPoint(ccp(0.5,1));
        buyPriseText1->setPosition(ccp(itemX1,  itemY2+5));
        pBGSprite -> addChild(buyPriseText1);
        
        
        
        CCMenuItemImage *buyBtn1 = CCMenuItemImage::create();
        buyBtn1->setNormalSpriteFrame(cache->spriteFrameByName("buybtn.png"));
        buyBtn1->setSelectedSpriteFrame(cache->spriteFrameByName("buybtn_click.png"));
        buyBtn1->initWithTarget(this, menu_selector(CBuyGoldLayer::buyGold) );
        buyBtn1->setPosition(ccp(itemX1, itemY3));
        buyBtn1->setTag(1);
        
        CCLabelTTF * buyBtnText1 = CCLabelTTF::create("buy", "STHeiti TC", 25);
        buyBtnText1->setAnchorPoint(ccp(0.5,0.5));
        buyBtnText1->setPosition(ccp(50, 35));
        buyBtn1 -> addChild(buyBtnText1);
        
        //222222
        
        CCSprite * goldIcon2 = CCSprite::createWithSpriteFrameName("gold_b.png");
        
        goldIcon2->setPosition(ccp(itemX2, itemY1));
        pBGSprite -> addChild(goldIcon2);
        
        
        char  cgoldnum2[64] ={0};
        sprintf(cgoldnum2, "X%d",(int)goldnumv[1]);
        
        CCLabelTTF * buyNumText2 = CCLabelTTF::create(cgoldnum2, "STHeiti TC", 25);
        buyNumText2->setColor(ccYELLOW);
        buyNumText2->setAnchorPoint(ccp(0,0));
        buyNumText2->setPosition(ccp(0, -30));
        goldIcon2 -> addChild(buyNumText2);
        
//        CCSprite * prires2 = CCSprite::createWithSpriteFrameName("goldnum_can.png");
//        prires2 -> setPosition(ccp(itemX2, itemY2));
//        pBGSprite -> addChild(prires2);
        
        buyPriseText2 = CCLabelTTF::create(CGameData::getInstance() -> strPrice2.c_str(), "STHeiti TC", 25);
        buyPriseText2->setAnchorPoint(ccp(0.5,1));
        buyPriseText2->setPosition(ccp(itemX2, itemY2+5));
        pBGSprite -> addChild(buyPriseText2);
        
        CCMenuItemImage *buyBtn2 = CCMenuItemImage::create();
        buyBtn2->setNormalSpriteFrame(cache->spriteFrameByName("buybtn.png"));
        buyBtn2->setSelectedSpriteFrame(cache->spriteFrameByName("buybtn_click.png"));
        buyBtn2->initWithTarget(this, menu_selector(CBuyGoldLayer::buyGold) );
        buyBtn2->setPosition(ccp(itemX2, itemY3));
        buyBtn2->setTag(2);
        
        CCLabelTTF * buyBtnText2 = CCLabelTTF::create("buy", "STHeiti TC", 25);
        buyBtnText2->setAnchorPoint(ccp(0.5,0.5));
        buyBtnText2->setPosition(ccp(50, 35));
        buyBtn2 -> addChild(buyBtnText2);

        
        
        
        if (CGameData::getInstance()->getStoreVerion() == STORE_GAME9) {
            //333333
            CCSprite * goldIcon3 = CCSprite::createWithSpriteFrameName("gold_c.png");
            
            goldIcon3->setPosition(ccp(itemX3, itemY1));
            pBGSprite -> addChild(goldIcon3);
            
            char cgoldnum3[64] ={0};
            sprintf(cgoldnum3, "X%d",goldnumv[2]);
            CCLabelTTF * buyNumText3 = CCLabelTTF::create(cgoldnum3, "STHeiti TC", 25);
            buyNumText3->setColor(ccYELLOW);
            buyNumText3->setAnchorPoint(ccp(0,0));
            buyNumText3->setPosition(ccp(0, -30));
            goldIcon3 -> addChild(buyNumText3);
            
            //        CCSprite * prires3 = CCSprite::createWithSpriteFrameName("goldnum_can.png");
            //        prires3 -> setPosition(ccp(itemX3, itemY2));
            //        pBGSprite -> addChild(prires3);
            
            buyPriseText3 = CCLabelTTF::create(CGameData::getInstance() -> strPrice3.c_str(), "STHeiti TC", 25);
            buyPriseText3->setAnchorPoint(ccp(0.5,1));
            buyPriseText3->setPosition(ccp(itemX3, itemY2 +5));
            pBGSprite -> addChild(buyPriseText3);
            
            CCMenuItemImage *buyBtn3 = CCMenuItemImage::create();
            buyBtn3->setNormalSpriteFrame(cache->spriteFrameByName("buybtn.png"));
            buyBtn3->setSelectedSpriteFrame(cache->spriteFrameByName("buybtn_click.png"));
            buyBtn3->initWithTarget(this, menu_selector(CBuyGoldLayer::buyGold) );
            buyBtn3->setPosition(ccp(itemX3, itemY3));
            
            CCLabelTTF * buyBtnText3 = CCLabelTTF::create("buy", "STHeiti TC", 25);
            buyBtnText3->setAnchorPoint(ccp(0.5,0.5));
            buyBtnText3->setPosition(ccp(50, 35));
            buyBtn3 -> addChild(buyBtnText3);
            buyBtn3->setTag(3);
            
            pBuyMenu = CCMenu::create( buyBtn1 ,buyBtn2 ,buyBtn3 , NULL);
        }else{
            
            pBuyMenu = CCMenu::create( buyBtn1 ,buyBtn2  , NULL);
        }
        
        
        
        pBuyMenu->setAnchorPoint(CCPointZero);
        pBuyMenu->setPosition( ccp(0, 0) );
        
        pBGSprite->addChild(pBuyMenu, 2);
        
        
        
        CCMenuItemImage *pCloseItem = CCMenuItemImage::create();
        pCloseItem->setNormalSpriteFrame(cache->spriteFrameByName("btn_main_close.png"));
        pCloseItem->setSelectedSpriteFrame(cache->spriteFrameByName("btn_main_close.png"));
        pCloseItem->initWithTarget(this, menu_selector(CBuyGoldLayer::closeLayer) );
//        pCloseItem->setPosition( ccp(330,415) );
        
        pMenu = CCMenu::create( pCloseItem, NULL);
        pMenu->setAnchorPoint(CCPointZero);
        pMenu->setPosition( ccp(403, 283) );
        
        pBGSprite->addChild(pMenu, 2);
        
        CCNotificationCenter::sharedNotificationCenter()->addObserver(this, callfuncO_selector(CBuyGoldLayer::receiveBuy1), "buygoods1", NULL);
        CCNotificationCenter::sharedNotificationCenter()->addObserver(this, callfuncO_selector(CBuyGoldLayer::receiveBuy2), "buygoods2", NULL);
        CCNotificationCenter::sharedNotificationCenter()->addObserver(this, callfuncO_selector(CBuyGoldLayer::receiveBuy3), "buygoods3", NULL);
        
        return true;
    }
    
    return false;
}

void CBuyGoldLayer::buyGold(CCObject * psender)
{
    CCMenuItemImage *pCloseItem = (CCMenuItemImage*)psender;
    CBaseSDKController::sharedInstance()-> buy(pCloseItem->getTag(), "");
}

void CBuyGoldLayer::closeLayer(CCObject* pSender)
{
    CSoundManager::getInstance()->playSound("sound/ui_button.ogg");
    
    CCNotificationCenter::sharedNotificationCenter()->postNotification("showItemTable");
    this->removeFromParentAndCleanup(true);
}

void CBuyGoldLayer::removeLayer()
{
    this->removeFromParentAndCleanup(true);
}

void CBuyGoldLayer::receiveBuy1()
{
    CGameData::getInstance()->gainGold(10000);
}
void CBuyGoldLayer::receiveBuy2()
{
    CGameData::getInstance()->gainGold(50000);
}
void CBuyGoldLayer::receiveBuy3()
{
    CGameData::getInstance()->gainGold(100000);
}

void CBuyGoldLayer::onExit()
{
    CCNotificationCenter::sharedNotificationCenter()->removeObserver(this, "buygoods1");
    CCNotificationCenter::sharedNotificationCenter()->removeObserver(this, "buygoods2");
    CCNotificationCenter::sharedNotificationCenter()->removeObserver(this, "buygoods3");
    CCLayer::onExit();
}


//void CBuyGoldLayer::setPriseByJson( char * prisejson)
//{

//    Json::Reader jsonReader;
//    Json::Value  jsonRoot;
//    
//    jsonReader.parse(prisejson , jsonRoot);
//    
//    std::string strPrice1 =
//                    
//    
//}
