//
//  BuyHeartLayer.cpp
//  runTileMap
//
//  Created by Mac on 14-11-7.
//
//

#include "BuyHeartLayer.h"

#include "GameData.h"

#include "baseSDKController.h"

#include "SoundManager.h"

CBuyHeartLayer::CBuyHeartLayer()
{
    
    
    pBGSprite = NULL;
    pTextSprite = NULL;
    pMenu = NULL;
}

CBuyHeartLayer::~CBuyHeartLayer()
{
    
}

bool CBuyHeartLayer::init()
{
    if (CCLayer::init( ) )
	{
        pBGSprite = CCSprite::createWithSpriteFrameName("buylayer_bg.png");
        pBGSprite->setAnchorPoint(CCPointZero);
        pBGSprite->setPosition(ccp(0, 0));
        addChild(pBGSprite);
        
//        pTextSprite = CCSprite::createWithSpriteFrameName("buylayer_text.png");
//        pTextSprite->setAnchorPoint(CCPointZero);
//        pTextSprite->setPosition(ccp(0, 0));
//        addChild(pTextSprite);
        
        CCLabelTTF * title = CCLabelTTF::create("Buy Hearts", "STHeiti TC", 40);
        title->setAnchorPoint(ccp(0.5,0));
        pBGSprite -> addChild(title);
        
        title->setPosition(ccp(pBGSprite->getContentSize().width/2, pBGSprite->getContentSize().height-65));
        
        
        
        CCSpriteFrameCache* cache = CCSpriteFrameCache::sharedSpriteFrameCache();
        
        int itemX1 = 84;
        int itemX2 = 224;
        int itemX3 = 364;
        int itemGad = 144;
        int itemY1 = 185;
        int itemY2 = 118;
        int itemY3 = 46;
        
        //11111111
        
        CCSprite * goldIcon1 = CCSprite::createWithSpriteFrameName("heartbuy.png");
        
        goldIcon1->setPosition(ccp(itemX1, itemY1));
        pBGSprite -> addChild(goldIcon1);
        
        CCLabelTTF * buyNumText1 = CCLabelTTF::create("X2", "STHeiti TC", 30);
        buyNumText1->setColor(ccYELLOW);
        buyNumText1->setAnchorPoint(ccp(0,0));
        buyNumText1->setPosition(ccp(0, -30));
        goldIcon1 -> addChild(buyNumText1);
        
        CCSprite * prires1 = CCSprite::createWithSpriteFrameName("goldnum_can.png");
        prires1 -> setPosition(ccp(itemX1, itemY2));
        pBGSprite -> addChild(prires1);
        
        CCLabelTTF * buyPriseText1 = CCLabelTTF::create("2000", "STHeiti TC", 25);
        buyPriseText1->setAnchorPoint(ccp(0,0));
        buyPriseText1->setPosition(ccp(30, 0));
        prires1 -> addChild(buyPriseText1);
        
        CCMenuItemImage *buyBtn1 = CCMenuItemImage::create();
        buyBtn1->setNormalSpriteFrame(cache->spriteFrameByName("buybtn.png"));
        buyBtn1->setSelectedSpriteFrame(cache->spriteFrameByName("buybtn_click.png"));
        buyBtn1->initWithTarget(this, menu_selector(CBuyHeartLayer::buyHeart) );
        buyBtn1->setPosition(ccp(itemX1, itemY3));
        buyBtn1->setTag(1);
        
        CCLabelTTF * buyBtnText1 = CCLabelTTF::create("buy", "STHeiti TC", 25);
        buyBtnText1->setAnchorPoint(ccp(0.5,0.5));
        buyBtnText1->setPosition(ccp(50, 35));
        buyBtn1 -> addChild(buyBtnText1);
        
        //222222
        
        CCSprite * goldIcon2 = CCSprite::createWithSpriteFrameName("heartbuy.png");
        
        goldIcon2->setPosition(ccp(itemX2, itemY1));
        pBGSprite -> addChild(goldIcon2);
        
        CCLabelTTF * buyNumText2 = CCLabelTTF::create("X5", "STHeiti TC", 30);
        buyNumText2->setColor(ccYELLOW);
        buyNumText2->setAnchorPoint(ccp(0,0));
        buyNumText2->setPosition(ccp(0, -30));
        goldIcon2 -> addChild(buyNumText2);
        
        CCSprite * prires2 = CCSprite::createWithSpriteFrameName("goldnum_can.png");
        prires2 -> setPosition(ccp(itemX2, itemY2));
        pBGSprite -> addChild(prires2);
        
        CCLabelTTF * buyPriseText2 = CCLabelTTF::create("4500", "STHeiti TC", 25);
        buyPriseText2->setAnchorPoint(ccp(0,0));
        buyPriseText2->setPosition(ccp(30, 0));
        prires2 -> addChild(buyPriseText2);
        
        CCMenuItemImage *buyBtn2 = CCMenuItemImage::create();
        buyBtn2->setNormalSpriteFrame(cache->spriteFrameByName("buybtn.png"));
        buyBtn2->setSelectedSpriteFrame(cache->spriteFrameByName("buybtn_click.png"));
        buyBtn2->initWithTarget(this, menu_selector(CBuyHeartLayer::buyHeart) );
        buyBtn2->setPosition(ccp(itemX2, itemY3));
        buyBtn2->setTag(2);
        
        CCLabelTTF * buyBtnText2 = CCLabelTTF::create("buy", "STHeiti TC", 25);
        buyBtnText2->setAnchorPoint(ccp(0.5,0.5));
        buyBtnText2->setPosition(ccp(50, 35));
        buyBtn2 -> addChild(buyBtnText2);
        
        //333333
        CCSprite * goldIcon3 = CCSprite::createWithSpriteFrameName("heartbuy.png");
        goldIcon3->setPosition(ccp(itemX3, itemY1));
        pBGSprite -> addChild(goldIcon3);
        
        
        CCLabelTTF * buyNumText3 = CCLabelTTF::create("X10", "STHeiti TC", 30);
        buyNumText3->setColor(ccYELLOW);
        buyNumText3->setAnchorPoint(ccp(0,0));
        buyNumText3->setPosition(ccp(0, -30));
        goldIcon3 -> addChild(buyNumText3);
    
        
        CCSprite * prires3 = CCSprite::createWithSpriteFrameName("goldnum_can.png");
        prires3 -> setPosition(ccp(itemX3, itemY2));
        pBGSprite -> addChild(prires3);
        
        CCLabelTTF * buyPriseText3 = CCLabelTTF::create("9000", "STHeiti TC", 25);
        buyPriseText3->setAnchorPoint(ccp(0,0));
        buyPriseText3->setPosition(ccp(30, 0));
        prires3 -> addChild(buyPriseText3);
        
        
        CCMenuItemImage *buyBtn3 = CCMenuItemImage::create();
        buyBtn3->setNormalSpriteFrame(cache->spriteFrameByName("buybtn.png"));
        buyBtn3->setSelectedSpriteFrame(cache->spriteFrameByName("buybtn_click.png"));
        buyBtn3->initWithTarget(this, menu_selector(CBuyHeartLayer::buyHeart) );
        buyBtn3->setPosition(ccp(itemX3, itemY3));
        buyBtn3->setTag(3);
        
        CCLabelTTF * buyBtnText3 = CCLabelTTF::create("buy", "STHeiti TC", 25);
        buyBtnText3->setAnchorPoint(ccp(0.5,0.5));
        buyBtnText3->setPosition(ccp(50, 35));
        buyBtn3 -> addChild(buyBtnText3);
        
        pBuyMenu = CCMenu::create( buyBtn1 ,buyBtn2 ,buyBtn3 , NULL);
        pBuyMenu->setAnchorPoint(CCPointZero);
        pBuyMenu->setPosition( ccp(0, 0) );
        
        pBGSprite->addChild(pBuyMenu, 2);
        
        
        
        CCMenuItemImage *pCloseItem = CCMenuItemImage::create();
        pCloseItem->setNormalSpriteFrame(cache->spriteFrameByName("btn_main_close.png"));
        pCloseItem->setSelectedSpriteFrame(cache->spriteFrameByName("btn_main_close.png"));
        pCloseItem->initWithTarget(this, menu_selector(CBuyHeartLayer::closeLayer) );
//        pCloseItem->setPosition( ccp(330,415) );
        
        pMenu = CCMenu::create( pCloseItem, NULL);
        pMenu->setAnchorPoint(CCPointZero);
        pMenu->setPosition( ccp(403, 283) );
        
        pBGSprite->addChild(pMenu, 2);
        
        return true;
    }
    
    return false;
}

void CBuyHeartLayer::buyHeart(CCObject * psender)
{
	int ok= 0;
    switch (((CCMenuItemImage*)psender)->getTag())
    {
        case 1:
            if (CGameData::getInstance()->getGold() >= 2000) {
                CGameData::getInstance()->costGold(2000);
                CGameData::getInstance()->addExHeartCnt(2);
                ok=1;
            }
            break;
        case 2:
            if (CGameData::getInstance()->getGold() >= 4500) {
                CGameData::getInstance()->costGold(4500);
                CGameData::getInstance()->addExHeartCnt(5);
                ok=1;
            }
            break;
        case 3:
            if (CGameData::getInstance()->getGold() >= 9000) {
                CGameData::getInstance()->costGold(9000);
                CGameData::getInstance()->addExHeartCnt(10);
                ok=1;
            }
            break;
        default:
            break;
    };
    if(ok==0){
    	CBaseSDKController::sharedInstance()->alertMsg("You dont have enough money,go to buy some!! ");
    }
}

void CBuyHeartLayer::closeLayer(CCObject* pSender)
{
    CSoundManager::getInstance()->playSound("sound/ui_button.ogg");
    
    CCNotificationCenter::sharedNotificationCenter()->postNotification("showItemTable");
    this->removeFromParentAndCleanup(true);
}

void CBuyHeartLayer::removeLayer()
{
    this->removeFromParentAndCleanup(true);
}
