﻿#include "CmySQLite.h"

#include "cocos2d.h"
//#include "FileUtil.h"

using namespace cocos2d;

CmySQLite::CmySQLite(void)
{
}

CmySQLite::~CmySQLite(void)
{
}

CmySQLite * CmySQLite::instance = NULL;

CmySQLite* CmySQLite::getInstance()
{
	if(instance == NULL)
	{
		instance = new CmySQLite();
	}
	return instance;
}
void CmySQLite::openDataBase(const char* writablePath, const char* filename, sqlite3** ppDb)
{
    char strFileName[256] = {'\0'};

    bool bRet = getLocalFile(writablePath, filename, strFileName);


	if( bRet && SQLITE_OK != sqlite3_open(strFileName, ppDb) )
	{
		sqlite3_close(*ppDb);
		*ppDb = NULL;
		CCLog("err open db file: %s, %s", filename, strFileName);
		CCLog("getLocalFile 100");
	}
}

bool CmySQLite::getLocalFile(const char* writablePath, const char* strInFile, char* strOutFile)
{
    std::string strTargetFile = writablePath;
	strTargetFile.append(strInFile);
    
	FILE* pFile = fopen( strTargetFile.c_str(), "r" );
	if(pFile )
	{
		fclose(pFile);
	}
	else
	{
		std::string strSourceFile = CCFileUtils::sharedFileUtils()->fullPathForFilename(strInFile);
        
		unsigned long ulSize = 0;
		unsigned char* pBuffer = CCFileUtils::sharedFileUtils()->getFileData(strSourceFile.c_str(), "rb", &ulSize);
		if (!pBuffer)
		{
			CCLog("err get data from file: %s", strSourceFile.c_str());
			return false;
		}
        
		FILE* fp = fopen(strTargetFile.c_str(), "wb");
		if (!fp)
		{
			CCLog("err open file(wb): %s", strTargetFile.c_str());
			return false;
		}
		int nLen = fwrite(pBuffer, 1, ulSize, fp);
        
		delete[] pBuffer;
		fclose(fp);
		fp = NULL;
        
		if (nLen < ulSize)
		{
			CCLog("err: read: %u, write %d", ulSize, nLen);
			return false;
		}
	}
	
	strcpy(strOutFile, strTargetFile.c_str());
	return true;
}


