//
//  Environment.h
//  runTileMap
//
//  Created by Mac on 14-8-18.
//
//

#ifndef __runTileMap__Environment__
#define __runTileMap__Environment__

#include "cocos2d.h"
#include "EnvironmentVO.h"
#include "GameData.h"
#include "Partner.h"

USING_NS_CC;
using namespace std;

class CPlayer;
//class CPartner;
class CEnvironment : public CCLayer
{
public:
    CEnvironment();
    ~CEnvironment();
    
    virtual void onEnter();
	virtual void onExit();
    
    static CEnvironment* create(int iStage, int iMapIndex = 1);
    void initEnvironment(int iStage, int iMapIndex);
    
    void move (CPlayer* player);
    void checkCollision (CPlayer * player);
    
    void onShowBridge();
    void hideBridge();
    
    CPartner* getPartner();
    
private:
    CC_SYNTHESIZE(float, m_fMoveDistance, MoveDistance);
    CC_SYNTHESIZE(int, m_iStage, Stage);
    CC_SYNTHESIZE(int, m_iMapIndex, MapIndex);
    
    CCArray* m_pEnvironmentSection_Array;

    CCSpriteBatchNode*  _pBatchNode_Gold1;
    CCSpriteBatchNode*  _pBatchNode_Gold5;
    CCSpriteBatchNode*  _pBatchNode_Gold10;
    CCSpriteBatchNode*  _pBatchNode_Gold20;
    CCSpriteBatchNode*  _pBatchNode_Gold40;
    
    CPartner*           pPartner;
    
    bool                _bShowBridge;
    int                 _iBridgeDuration;

};

#endif /* defined(__runTileMap__Environment__) */
