//
//  EnvironmentVO.h
//  runTileMap
//
//  Created by Mac on 14-8-18.
//
//

#ifndef runTileMap_EnvironmentVO_h
#define runTileMap_EnvironmentVO_h

#include "cocos2d.h"
USING_NS_CC;
using namespace std;

class CEnvironmentVO : public CCObject
{
public:
    CEnvironmentVO()
    {
        _pGoldSetArray = CCArray::create();
        _pGoldSetArray->retain();
        _pRoadBlockArray = CCArray::create();
        _pRoadBlockArray->retain();
        _pItemArray = CCArray::create();
        _pItemArray->retain();
        
        m_TerrainCollisionVector.clear();
        m_BoardCollisionVector.clear();
    }
    
    ~CEnvironmentVO()
    {
        m_TerrainCollisionVector.clear();
        m_BoardCollisionVector.clear();
        
        _pGoldSetArray->removeAllObjects();
        CC_SAFE_DELETE(_pGoldSetArray);
        _pRoadBlockArray->removeAllObjects();
        CC_SAFE_DELETE(_pRoadBlockArray);
        _pItemArray->removeAllObjects();
        CC_SAFE_DELETE(_pItemArray);
    }
    
public:
    CC_SYNTHESIZE(cocos2d::CCTMXTiledMap*, _tileMap, Tilemap);
//    CC_SYNTHESIZE(cocos2d::CCTMXLayer*, _background, Background);
    vector<CCRect>  m_TerrainCollisionVector;
    vector<CCRect>  m_BoardCollisionVector;
    CC_SYNTHESIZE(CCArray*, _pGoldSetArray, GoldSetArray);
    CC_SYNTHESIZE(CCArray*, _pItemArray, ItemArray);
    CC_SYNTHESIZE(CCArray*, _pRoadBlockArray, RoadBlockArray);
};


#endif
