//
//  GameData.cpp
//  runTileMap
//
//  Created by Mac on 14-8-18.
//
//

#include "GameData.h"
#include "CmySQLite.h"
#include "ItemVO.h"

CGameData* CGameData::m_pInstance = NULL;
//CGameData* g_pGameData = CGameData::getInstance();

const int HEART_INTERVAL = 300;	// 30 miniutes

CGameData::CGameData()
{
    m_ScreenSize = CCDirector::sharedDirector()->getWinSize();
}

CGameData::~CGameData()
{
    if(m_db_DataBase)
    {
        sqlite3_close(m_db_DataBase);
    }
}

CGameData * CGameData::getInstance(void)
{
	if (!m_pInstance)
	{
		m_pInstance = new CGameData();
//		CCFileUtils::sharedFileUtils()->getWritablePath();
		m_pInstance->init();
        

	}
    
	return m_pInstance;
}

bool CGameData::init()
{
     strPrice1 = "";
     strPrice2 = "";
     strPrice3 = "";
    
	std::string writablePath = CCFileUtils::sharedFileUtils()->getWritablePath();

    CmySQLite::getInstance()->openDataBase(writablePath.c_str(), "RunData.db", &m_db_DataBase);
    int itemRow=0,itemColumn=0;
	char **itemResult;
    char szExecute[256]={0};

    sprintf(szExecute,"Select t_player.* FROM t_player");
    sqlite3_get_table(m_db_DataBase,szExecute,&itemResult,&itemRow,&itemColumn,NULL);

    m_iHeart = atoi(itemResult[3]);
    m_iGold = atoi(itemResult[5]);
    m_iAbsorbLevel = atoi(itemResult[7]);
    m_iAccelerate = atoi(itemResult[9]);
    m_iGiantLevel = atoi(itemResult[11]);
    m_iPetLevel = atoi(itemResult[13]);
    m_iFood = atoi(itemResult[15]);
    m_iMedicalKit = atoi(itemResult[17]);
    m_iShell = atoi(itemResult[19]);
    
    m_iTopScore = atoi(itemResult[21]);
    m_iLastWeekTopScore = atoi(itemResult[23]);
    m_iWeekTopScore = atoi(itemResult[25]);
    m_iTopRunDistance = atoi(itemResult[27]);
    
    m_bSoundEnable = atoi(itemResult[29]);
    m_bMusicEnable = atoi(itemResult[31]);
    m_bEffectEnable = atoi(itemResult[33]);
    
    m_iPet1 = atoi(itemResult[37]);
    m_iPet2 = atoi(itemResult[39]);
    m_iPet3 = atoi(itemResult[41]);
    
    
    updateLastWeekBestScore();
    
    sqlite3_free_table(itemResult);
    
    m_ipConsumableArray = CCArray::create();
    m_ipConsumableArray->retain();
    
    ItemVO* pFoodItem = new ItemVO();
    pFoodItem->iItemType = 1;
    pFoodItem->iID = 11;
    pFoodItem->iItemLevel = m_iFood;
    pFoodItem->getData();
    m_ipConsumableArray->addObject(pFoodItem);
    ItemVO* pMedicalKitItem = new ItemVO();
    pMedicalKitItem->iItemType = 1;
    pMedicalKitItem->iID = 12;
    pMedicalKitItem->iItemLevel = m_iMedicalKit;
    pMedicalKitItem->getData();
    m_ipConsumableArray->addObject(pMedicalKitItem);
    ItemVO* pShellItem = new ItemVO();
    pShellItem->iItemType = 1;
    pShellItem->iID = 13;
    pShellItem->iItemLevel = m_iShell;
    pShellItem->getData();
    m_ipConsumableArray->addObject(pShellItem);
    
    ItemVO* pPetItem = new ItemVO();
    pPetItem->iItemType = 1;
    pPetItem->iID = 14;
    pPetItem->iItemLevel = m_iPet1;
    pPetItem->getData();
    m_ipConsumableArray->addObject(pPetItem);
    
    ItemVO* pPetItem2 = new ItemVO();
    pPetItem2->iItemType = 1;
    pPetItem2->iID = 15;
    pPetItem2->iItemLevel = m_iPet2;
    pPetItem2->getData();
    m_ipConsumableArray->addObject(pPetItem2);
    
    ItemVO* pPetItem3 = new ItemVO();
    pPetItem3->iItemType = 1;
    pPetItem3->iID = 16;
    pPetItem3->iItemLevel = m_iPet3;
    pPetItem3->getData();
    m_ipConsumableArray->addObject(pPetItem3);
    
    m_ipUpgradesArray = CCArray::create();
    m_ipUpgradesArray->retain();
    
    ItemVO* pAbsorbItem = new ItemVO();
    pAbsorbItem->iItemType = 2;
    pAbsorbItem->iID = 1;
    pAbsorbItem->iItemLevel = m_iAbsorbLevel;
    pAbsorbItem->getData();
    m_ipUpgradesArray->addObject(pAbsorbItem);
    ItemVO* pAccelerateItem = new ItemVO();
    pAccelerateItem->iItemType = 2;
    pAccelerateItem->iID = 2;
    pAccelerateItem->iItemLevel = m_iAccelerate;
    pAccelerateItem->getData();
    m_ipUpgradesArray->addObject(pAccelerateItem);
    
    ItemVO* pGiantItem = new ItemVO();
    pGiantItem->iItemType = 2;
    pGiantItem->iID = 3;
    pGiantItem->iItemLevel = m_iGiantLevel;
    pGiantItem->getData();
    m_ipUpgradesArray->addObject(pGiantItem);
    
    
	return true;
}

void CGameData::gainGold(int value)
{
    setGold(getGold() + value);
    
    CCNotificationCenter::sharedNotificationCenter()->postNotification("updateData");
    updateData();
}

void CGameData::costGold(int value)
{
    setGold(getGold() - value);
    CCNotificationCenter::sharedNotificationCenter()->postNotification("updateData");
    updateData();
}

bool CGameData::updateData()
{
    char szExecute[256]={0};
    char* errmsg;
    int nResult = 0;
    //生命值
    sprintf(szExecute, "update t_player set Sum = %d where Attribute = 'Heart'", m_iHeart);
    nResult = sqlite3_exec(m_db_DataBase,szExecute, NULL, NULL,&errmsg);
    if (nResult != SQLITE_OK)
    {
        sqlite3_close(m_db_DataBase);
        sqlite3_free(errmsg);
        return false;
    }
    //金币
    sprintf(szExecute, "update t_player set Sum = %d where Attribute = 'Gold'", m_iGold);
    nResult = sqlite3_exec(m_db_DataBase,szExecute, NULL, NULL,&errmsg);
    if (nResult != SQLITE_OK)
    {
        sqlite3_close(m_db_DataBase);
        sqlite3_free(errmsg);
        return false;
    }
    //磁铁等级
    sprintf(szExecute, "update t_player set Sum = %d where Attribute = 'AbosrbLevel'", m_iAbsorbLevel);
    nResult = sqlite3_exec(m_db_DataBase,szExecute, NULL, NULL,&errmsg);
    if (nResult != SQLITE_OK)
    {
        sqlite3_close(m_db_DataBase);
        sqlite3_free(errmsg);
        return false;
    }
    ItemVO* pAbsorbItem = (ItemVO*)m_ipUpgradesArray->objectAtIndex(0);
    pAbsorbItem->iItemLevel = m_iAbsorbLevel;
    pAbsorbItem->getData();
    //加速器等级
    sprintf(szExecute, "update t_player set Sum = %d where Attribute = 'AccelerateLevel'", m_iAccelerate);
    nResult = sqlite3_exec(m_db_DataBase,szExecute, NULL, NULL,&errmsg);
    if (nResult != SQLITE_OK)
    {
        sqlite3_close(m_db_DataBase);
        sqlite3_free(errmsg);
        return false;
    }
    ItemVO* pAccelerateItem = (ItemVO*)m_ipUpgradesArray->objectAtIndex(1);
    pAccelerateItem->iItemLevel = m_iAccelerate;
    pAccelerateItem->getData();
    //无敌等级
    sprintf(szExecute, "update t_player set Sum = %d where Attribute = 'GiantLevel'", m_iGiantLevel);
    nResult = sqlite3_exec(m_db_DataBase,szExecute, NULL, NULL,&errmsg);
    if (nResult != SQLITE_OK)
    {
        sqlite3_close(m_db_DataBase);
        sqlite3_free(errmsg);
        return false;
    }
    ItemVO* pGiantLevelItem = (ItemVO*)m_ipUpgradesArray->objectAtIndex(2);
    pGiantLevelItem->iItemLevel = m_iGiantLevel;
    pGiantLevelItem->getData();
    //宠物等级
    sprintf(szExecute, "update t_player set Sum = %d where Attribute = 'PetLevel'", m_iPetLevel);
    nResult = sqlite3_exec(m_db_DataBase,szExecute, NULL, NULL,&errmsg);
    if (nResult != SQLITE_OK)
    {
        sqlite3_close(m_db_DataBase);
        sqlite3_free(errmsg);
        return false;
    }
    
    ItemVO* pFoodItem = (ItemVO*)m_ipConsumableArray->objectAtIndex(0);
    pFoodItem->iItemLevel = m_iFood;
    //医药包数量
    sprintf(szExecute, "update t_player set Sum = %d where Attribute = 'MedicalKit'", m_iMedicalKit);
    nResult = sqlite3_exec(m_db_DataBase,szExecute, NULL, NULL,&errmsg);
    if (nResult != SQLITE_OK)
    {
        sqlite3_close(m_db_DataBase);
        sqlite3_free(errmsg);
        return false;
    }
    ItemVO* pMedicalKitItem = (ItemVO*)m_ipConsumableArray->objectAtIndex(1);
    pMedicalKitItem->iItemLevel = m_iMedicalKit;
    //盾牌数量
    sprintf(szExecute, "update t_player set Sum = %d where Attribute = 'Shell'", m_iShell);
    nResult = sqlite3_exec(m_db_DataBase,szExecute, NULL, NULL,&errmsg);
    if (nResult != SQLITE_OK)
    {
        sqlite3_close(m_db_DataBase);
        sqlite3_free(errmsg);
        return false;
    }
    ItemVO* pShellItem = (ItemVO*)m_ipConsumableArray->objectAtIndex(2);
    pShellItem->iItemLevel = m_iShell;
    
    
    //---设置---
    //音效
    sprintf(szExecute, "update t_player set Sum = %d where Attribute = 'SoundEnable'", m_bSoundEnable);
    nResult = sqlite3_exec(m_db_DataBase,szExecute, NULL, NULL,&errmsg);
    if (nResult != SQLITE_OK)
    {
        sqlite3_close(m_db_DataBase);
        sqlite3_free(errmsg);
        return false;
    }
    //音乐
    sprintf(szExecute, "update t_player set Sum = %d where Attribute = 'MusicEnable'", m_bMusicEnable);
    nResult = sqlite3_exec(m_db_DataBase,szExecute, NULL, NULL,&errmsg);
    if (nResult != SQLITE_OK)
    {
        sqlite3_close(m_db_DataBase);
        sqlite3_free(errmsg);
        return false;
    }
    //特效
    sprintf(szExecute, "update t_player set Sum = %d where Attribute = 'EffectEnable'", m_bEffectEnable);
    nResult = sqlite3_exec(m_db_DataBase,szExecute, NULL, NULL,&errmsg);
    if (nResult != SQLITE_OK)
    {
        sqlite3_close(m_db_DataBase);
        sqlite3_free(errmsg);
        return false;
    }
    
    
    //宠物
    
    sprintf(szExecute, "update t_player set Sum = %d where Attribute = 'pet1'", m_iPet1);
    nResult = sqlite3_exec(m_db_DataBase,szExecute, NULL, NULL,&errmsg);
    if (nResult != SQLITE_OK)
    {
        sqlite3_close(m_db_DataBase);
        sqlite3_free(errmsg);
        return false;
    }
    ItemVO* pPetItem1 = (ItemVO*)m_ipConsumableArray->objectAtIndex(3);
    pPetItem1->iItemLevel = m_iPet1;
    
    sprintf(szExecute, "update t_player set Sum = %d where Attribute = 'pet2'", m_iPet2);
    nResult = sqlite3_exec(m_db_DataBase,szExecute, NULL, NULL,&errmsg);
    if (nResult != SQLITE_OK)
    {
        sqlite3_close(m_db_DataBase);
        sqlite3_free(errmsg);
        return false;
    }
    ItemVO* pPetItem2 = (ItemVO*)m_ipConsumableArray->objectAtIndex(4);
    pPetItem2->iItemLevel = m_iPet2;
    
    sprintf(szExecute, "update t_player set Sum = %d where Attribute = 'pet3'", m_iPet3);
    nResult = sqlite3_exec(m_db_DataBase,szExecute, NULL, NULL,&errmsg);
    if (nResult != SQLITE_OK)
    {
        sqlite3_close(m_db_DataBase);
        sqlite3_free(errmsg);
        return false;
    }
    ItemVO* pPetItem3 = (ItemVO*)m_ipConsumableArray->objectAtIndex(5);
    pPetItem3->iItemLevel = m_iPet3;
    
    
//    ItemVO* pPetLevelItem = (ItemVO*)m_ipConsumableArray->objectAtIndex(3);
//    pPetLevelItem->iItemLevel = m_iPetLevel;
//    pPetLevelItem->getData();
    
    
    //食物数量
    sprintf(szExecute, "update t_player set Sum = %d where Attribute = 'Food'", m_iFood);
    nResult = sqlite3_exec(m_db_DataBase,szExecute, NULL, NULL,&errmsg);
    if (nResult != SQLITE_OK)
    {
        sqlite3_close(m_db_DataBase);
        sqlite3_free(errmsg);
        return false;
    }
    
    return true;
}

bool CGameData::updateScore()
{
    char szExecute[256]={0};
    char* errmsg;
    int nResult = 0;
    
    if (m_iRunScore > m_iWeekTopScore)
    {
        //本周最高成绩
        m_iWeekTopScore = m_iRunScore;
        sprintf(szExecute, "update t_player set Sum = %d where Attribute = 'WeekTopScore'", m_iWeekTopScore);
        nResult = sqlite3_exec(m_db_DataBase,szExecute, NULL, NULL,&errmsg);
        if (nResult != SQLITE_OK)
        {
            sqlite3_close(m_db_DataBase);
            sqlite3_free(errmsg);
            return false;
        }
    }
    
    if (m_iRunScore > m_iTopScore)
    {
        //历史最高成绩
        m_iTopScore = m_iRunScore;
        sprintf(szExecute, "update t_player set Sum = %d where Attribute = 'TopScore'", m_iTopScore);
        nResult = sqlite3_exec(m_db_DataBase,szExecute, NULL, NULL,&errmsg);
        if (nResult != SQLITE_OK)
        {
            sqlite3_close(m_db_DataBase);
            sqlite3_free(errmsg);
            return false;
        }
    }
    
    if (m_iRunDistance > m_iTopRunDistance)
    {
        //历史最远路程
        m_iTopRunDistance = m_iRunDistance;
        sprintf(szExecute, "update t_player set Sum = %d where Attribute = 'TopRunDistance'", m_iTopRunDistance);
        nResult = sqlite3_exec(m_db_DataBase,szExecute, NULL, NULL,&errmsg);
        if (nResult != SQLITE_OK)
        {
            sqlite3_close(m_db_DataBase);
            sqlite3_free(errmsg);
            return false;
        }
    }
    
    
    
    
    return true;
}

int CGameData::getWhatDay()
{
    cc_timeval now;
    CCTime::gettimeofdayCocos2d(&now, NULL);
    struct tm * tm;
    time_t tp = now.tv_sec;
    tm = localtime(&tp);
    int year = tm->tm_year + 1900;
    int month = tm->tm_mon + 1;
    int day = tm->tm_mday;
    int centry = year/100;
    year = year%100;
    
    int whatDay;
    whatDay = year + (year/4) + (centry/4)-2*centry + (26*(month+1)/10) + day-1;
    whatDay = whatDay%7;
    
    return whatDay;
}

void CGameData::updateLastWeekBestScore() //本周第一次登陆
{
    if (getWhatDay() == 1 && m_iLastLoginDay != getWhatDay())
    {
        m_iLastWeekTopScore = m_iWeekTopScore;
        m_iWeekTopScore = 0;
        
        char szExecute[256]={0};
        char* errmsg;
        int nResult = 0;
        //上周最高分
        sprintf(szExecute, "update t_player set Sum = %d where Attribute = 'LastWeekTopScore'", m_iLastWeekTopScore);
        nResult = sqlite3_exec(m_db_DataBase,szExecute, NULL, NULL,&errmsg);
        if (nResult != SQLITE_OK)
        {
            sqlite3_close(m_db_DataBase);
            sqlite3_free(errmsg);
        }
        //本周最高分
        sprintf(szExecute, "update t_player set Sum = %d where Attribute = 'WeekTopScore'", m_iWeekTopScore);
        nResult = sqlite3_exec(m_db_DataBase,szExecute, NULL, NULL,&errmsg);
        if (nResult != SQLITE_OK)
        {
            sqlite3_close(m_db_DataBase);
            sqlite3_free(errmsg);
        }
        //上次登陆时间
        sprintf(szExecute, "update t_player set Sum = %d where Attribute = 'LastLoginDay'", getWhatDay());
        nResult = sqlite3_exec(m_db_DataBase,szExecute, NULL, NULL,&errmsg);
        if (nResult != SQLITE_OK)
        {
            sqlite3_close(m_db_DataBase);
            sqlite3_free(errmsg);
        }
    }
}

int  CGameData::getHeartCnt()
{
	return m_iHeart;
}

void CGameData::setMaxHerat(int nCnt)
{
    m_nMaxHeart = nCnt;
}

int  CGameData::addHeartCnt(int nCnt)
{
    if (m_iHeart > MAX_HEART) {
        return m_iHeart;
    }
	m_iHeart += nCnt;
	if (m_iHeart > MAX_HEART)
	{
		m_iHeart = MAX_HEART;
	}
	updateData();
    
	return m_iHeart;
}

int  CGameData::addExHeartCnt(int nCnt)
{
    m_iHeart += nCnt;
	updateData();
    
	return m_iHeart;
}

int  CGameData::addOneHeartCnt()
{
	return addHeartCnt(1);
}

int  CGameData::subOneHeartCnt()
{
	if (m_iHeart > 0)
	{
        
		if (m_iHeart >= MAX_HEART)
		{
			m_nHeartTime = GetTimeSecond();
		}
		m_iHeart--;
		updateData();
	}
	return m_iHeart;
}

int CGameData::getHeartWaitTime()
{
	int nNow = GetTimeSecond();
	if (nNow > m_nHeartTime)
	{
		int nOffset = nNow - m_nHeartTime;
		int nAddHeart = nOffset / HEART_INTERVAL;
		if (nAddHeart > 0)
		{
            if (m_iHeart > MAX_HEART) {
                
            }else{
                m_iHeart += nAddHeart;
                if (m_iHeart > MAX_HEART)
                {
                    m_iHeart = MAX_HEART;
                }
            }
			
            
            
            
			m_nHeartTime += (nAddHeart * HEART_INTERVAL);
		}
	}
    
	if (m_iHeart < MAX_HEART
		&& nNow >= m_nHeartTime)
	{
		int nWaitTime = HEART_INTERVAL - ( (nNow - m_nHeartTime) % HEART_INTERVAL );
		return nWaitTime;
	}
	else if(nNow < m_nHeartTime)
	{
		return -1;
	}
    
	return 0;
}

unsigned long long CGameData::getTime()
{
	timeval tv;
	gettimeofday(&tv, NULL);
	return (tv.tv_sec * 1000) + (tv.tv_usec / 1000);
}

int CGameData::GetTimeSecond()
{
	timeval tv;
	gettimeofday(&tv, NULL);
	return tv.tv_sec;
}
