//
//  GameData.h
//  runTileMap
//
//  Created by Mac on 14-8-18.
//
//

#ifndef __runTileMap__GameData__
#define __runTileMap__GameData__

#include "cocos2d.h"
#include <sqlite3.h>
USING_NS_CC;

#define BackGround_Z 100
#define Terrain_Z 200
#define Player_Z 300
#define Item_Z 250
#define UI_Z 500
#define MAX_HEART 10

enum STORE_ENUM
{
    
    STORE_GOOGLEPLAY = 2,
     STORE_GAME9 = 3,
    
};

enum ITEM_TYPE_ENUM
{
    
    
};
class CGameData : public cocos2d::CCObject
{
public:
    CGameData();
    ~CGameData();
    
    static CGameData* getInstance();
    static CGameData* m_pInstance;
    
    STORE_ENUM getStoreVerion()
    {
        return STORE_GOOGLEPLAY;
    }
    std::vector<int> getBuyGoldNum()
    {
        std::vector<int> goldNumV;
        if (getStoreVerion() == STORE_GOOGLEPLAY) {
            goldNumV.push_back(200000);
            goldNumV.push_back(300000);
        }else if(getStoreVerion() == STORE_GAME9) {
            goldNumV.push_back(10000);
            goldNumV.push_back(50000);
            goldNumV.push_back(100000);
        }
        
        return goldNumV;
    }
    
    bool init();
    bool updateData();
    bool updateScore();
    
    int  getWhatDay();
    void updateLastWeekBestScore();
    
    
    void gainGold(int value);
    void costGold(int value);
    
    int  getMaxHeart() { return m_nMaxHeart; }
    void setMaxHerat(int nCnt);
    
	int  getHeartCnt();
	int  addOneHeartCnt();
	int  subOneHeartCnt();
	int  addHeartCnt(int nCnt);
    int  addExHeartCnt(int nCnt);
	int  getHeartWaitTime();
    
    unsigned long long getTime();    
    int  GetTimeSecond();
    
    
    std::string strPrice1;
    
    std::string  strPrice2;
    std::string  strPrice3;

private:
    sqlite3*		m_db_DataBase;
    
    CC_SYNTHESIZE(CCSize, m_ScreenSize,    ScreenSize);
    
    CC_SYNTHESIZE(int,    m_iHeart,        Heart);
    CC_SYNTHESIZE(int,    m_iGold,         Gold);
    
    int     m_nMaxHeart;
//	int		m_nHeartCnt;
	int 	m_nHeartTime;
    
    //道具等级
    CC_SYNTHESIZE(int,    m_iAbsorbLevel,  AbsrobLevel);
    CC_SYNTHESIZE(int,    m_iAccelerate,   AccelerateLevel);
    CC_SYNTHESIZE(int,    m_iGiantLevel,   GiantLevel);
    CC_SYNTHESIZE(int,    m_iPetLevel,     PetLevel);
    CC_SYNTHESIZE(int,    m_iFood,         Food);
    CC_SYNTHESIZE(int,    m_iMedicalKit,   MedicalKit);
    CC_SYNTHESIZE(int,    m_iShell,        Shell);
    CC_SYNTHESIZE(int,    m_iPet1,        Pet1);
    CC_SYNTHESIZE(int,    m_iPet2,        Pet2);
    CC_SYNTHESIZE(int,    m_iPet3,        Pet3);
    
    //设置
    CC_SYNTHESIZE(bool,   m_bSoundEnable,  SoundEnable);
    CC_SYNTHESIZE(bool,   m_bMusicEnable,  MusicEnable);
    CC_SYNTHESIZE(bool,   m_bEffectEnable, EffectEnable);
    
    //记录
    CC_SYNTHESIZE(int,    m_iTopRunDistance,    TopRunDistance);    //最远距离
    CC_SYNTHESIZE(int,    m_iTopScore,          TopScore);          //最高分
    CC_SYNTHESIZE(int,    m_iLastWeekTopScore,  LastWeekTopScore);  //上周最高分
    CC_SYNTHESIZE(int,    m_iWeekTopScore,      WeekTopScore);      //本周最高分
    CC_SYNTHESIZE(int,    m_iRunScore,          RunScore);          //本次分数
    CC_SYNTHESIZE(int,    m_iRunDistance,       RunDistance);       //本次距离
    CC_SYNTHESIZE(int,    m_iGainGold,          GainGold);          //本次获得金币
    
    //道具列表
    CC_SYNTHESIZE(CCArray*,    m_ipConsumableArray,  ConsumableArray);  //商城，消耗品
    CC_SYNTHESIZE(CCArray*,    m_ipUpgradesArray,    UpgradesArray);    //升级
    
    int m_iLastLoginDay;
    

    
};

#endif /* defined(__runTileMap__GameData__) */
