//
//  GameModel.cpp
//  runTileMap
//
//  Created by Mac on 14-11-10.
//
//

#include "GameModel.h"

GameModel * GameModel::instance = NULL;

GameModel * GameModel::getInstance()
{
    if (instance == NULL) {
        instance = new GameModel();
        instance ->isJustOpen = true;
        
    }
    return instance;
}


void GameModel::init()
{
    bool isFirstTimeOpen = !kGetBooleanFromXML("isExistUserData");
    if (isFirstTimeOpen) {
        
        kSetBooleanToXML("isExistUserData" , true);
        for (int i = 1; i<10; i++) {
            
            char achieveStrKey[256] = {'\0'};
            sprintf(achieveStrKey, "achieveKey_%d",i);
            CCUserDefault::sharedUserDefault()->setBoolForKey(achieveStrKey, false);
            kFlushUserDefalt;
        }
        
        
        CCUserDefault::sharedUserDefault()->setBoolForKey("hasDoNewHand", false);
        
        
        kSetBooleanToXML("DownloadUC",false);
        kSetBooleanToXML("ShareToFace",false);
        
        kSetIntegerToXML("achieveReach",0);
        iAchieveReach = 0;
        
        kFlushUserDefalt;
        
        hasDoNewHand = false;
    }else{
        DownloadUC = kGetBooleanFromXML("DownloadUC");
        iAchieveReach = kGetIntegerFromXML("achieveReach");
    }
    
    mapAchieves.insert(std::pair<int , int>(1,100));
    mapAchieves.insert(std::pair<int , int>(2,500));
    mapAchieves.insert(std::pair<int , int>(3,1500));
    mapAchieves.insert(std::pair<int , int>(4,3000));
    mapAchieves.insert(std::pair<int , int>(5,200000));
    mapAchieves.insert(std::pair<int , int>(6,400000));
    
    usingPet = 1;
}

void GameModel::hasDoNewHandOK()
{
    kSetBooleanToXML("hasDoNewHand",true);
}

void GameModel::checkAchieve(int _moveDist , int _getGold)
{
    
    if (iAchieveReach == mapAchieves.size()) {
        return;
    }
    int target = (int)mapAchieves[iAchieveReach+1];
    if (iAchieveReach < 4) {
        if (_moveDist >= target) {
            reachAchieve(iAchieveReach+1);
        }
    }else if(iAchieveReach >=4){
        if (_getGold >= target) {
            reachAchieve(iAchieveReach+1);
        }
    }
    
}


void  GameModel::reachAchieve(int m_index)
{
    
    char achieveStrKey[256] = {'\0'};
    sprintf(achieveStrKey, "achieveKey_%d",m_index);
    CCUserDefault::sharedUserDefault()->setBoolForKey(achieveStrKey, true);
    
    iAchieveReach = m_index;
    kSetIntegerToXML("achieveReach",m_index);
    kFlushUserDefalt;
}

bool GameModel::isReachAchieve(int m_index)
{
    char achieveStrKey[256] = {'\0'};
    sprintf(achieveStrKey, "achieveKey_%d",m_index);
    return kGetBooleanFromXML(achieveStrKey);
}

bool GameModel::isMission1ok()
{
    
    return kGetBooleanFromXML("DownloadUC");
}
bool GameModel::isMission2ok()
{
    
    return kGetIntegerFromXML("achieveReach");
}
void GameModel::mission1ok()
{
    kSetBooleanToXML("DownloadUC",true);
    kFlushUserDefalt;
}
void GameModel::mission2ok()
{
    kSetBooleanToXML("achieveReach",true);
    kFlushUserDefalt;
}
