//
//  GameScene.h
//  runTileMap
//
//  Created by Mac on 14-8-14.
//
//

#ifndef __runTileMap__GameScene__
#define __runTileMap__GameScene__

#include "cocos2d.h"
#include "GameData.h"
USING_NS_CC;
using namespace std;

class CPlayer;
class CPartner;
class CPet;
class CEnvironment;

class CGameScene : public cocos2d::CCLayer
{
public:
    CGameScene();
    ~CGameScene();
    
    virtual bool init();
    static cocos2d::CCScene* scene();
    CREATE_FUNC(CGameScene);
    
    virtual void onEnter();
	virtual void onExit();

	void addAlert(CCObject* pSender);
    void closeAlert(CCObject* pSender);
private:
    virtual void registerWithTouchDispatcher(void);
    virtual void ccTouchesBegan(CCSet *pTouches, CCEvent *pEvent);
	virtual void ccTouchesEnded(CCSet *pTouches, CCEvent *pEvent);
    void update (float dt);
    
    void initUI();
    
    void initEnvironment();
    void initPlayer();
    void initPet();
//    void setViewpointCenter(CCPoint position);
    void initBackGround();
    void updateBackGround(float xMove);
    void changeBackGround(int iStage);
    void changeMap(int iStage, int iIndex);
    
    void initEffect();
    void updateRunEffect(CCObject* pSender);
    void removeEffect(CCObject* pSender);
    void removeSprite(CCObject* pSender);
    
    //事件更新
    void updateHealthBar(CCObject* pSender);
    void updateVITBar(CCObject* pSender);
    void updateGoldeBar(CCObject* pSender);
    void updateMoveDistance(CCObject* pSender);
    
    void onTakeABreak(CCObject* pSender);
    void onFinishBreak();
    
    void onAccelerateCountDown(CCObject* pSender);
    void updateAccelerateCountDown();
    
    void onAbsortCountDown(CCObject * pSender);
    void onGaintCountDown(CCObject * pSender);
    
    
    
    void updateToSpaceCountDown();
//    void onAbsorbCountDown(CCObject* pSender);
//    void updateAbsorbCountDown();
//    void onGiantCountDown(CCObject* pSender);
//    void updateGiantCountDown();
    void updateMapIndex(CCObject* pSender);
    
    void onPortalCall(CCObject* pSender);
    void onBonusMap(CCObject* pSender);
    void onCompleteBonusMap(CCObject* pSender);
    
    void completePopUpDistance(CCObject* pSender);
    void onResumeGame(CCObject* pSender);
    
    
    
    //按钮控制
    void jump();
    void slip();
    void menuPauseCallback(CCObject* pSender);
    void startGameCountDown();
    
    void popUpReborn();
    void reborn(CCObject* pSender);
    void back2MainView(CCObject* pSender);

    void newHandAchieveCheck(int _moveDist);
    void removeNewHand();
private:
    CCSize              _screenSize;
    CPlayer*            m_pPlayer;
//    CPartner*           m_pPartner;
    CPet*               m_pPet;
    CEnvironment*       m_pEnvironment;
    
    CCSpriteBatchNode*  _frontground;
    CCSpriteBatchNode*  _background;
    CCSpriteBatchNode*  _clound;
    
    int                 _iBGIndex;
    int                 _iBGRepeatCount;
    bool                _bChangeMap;
    bool                _bBonusMap;
    bool                _bCompleteBonusMap;
    
    CCSprite*           m_pItemTime;
    CCProgressTimer*    m_pItemTimeProgress;
    CCArray*            m_pHeartArray;
    CCLabelTTF*         m_pVIT_Label;    
    CCLabelAtlas*       pBonusLabel;
    CCSprite*           m_pBonusSprite;
    
    CCSprite*           m_pDistanceSprite;
    bool                m_bPopUpDistance;
    
    
    CCLabelTTF*         m_pGoldLabel;
    CCLabelTTF*         m_pMoveDistanceLabel;
    CCLabelTTF*         m_pMapIndexLabel;
    
    int                 m_iGold;
    int                 m_iBonusGold;
    float               m_fMoveDistance;
    
    int                 m_iCountDown;
    int                 m_iCountDownTotal;
    int                 m_iRebornChance;
    
    CCLayer*            m_pResurrectionLayer;
    CCSprite*           m_pResurrectionTimerSprite;
    CCSprite*           m_pResurrectionTimeSprite;
    int                 m_iResurrectionTime;
    
    CCLabelTTF*         m_pMedicKitAmountLabel;
    
    
    CCLayer*            m_pUILayer;
    
    CCSprite *           progBackSp;
    CCProgressTimer*    m_pToSpaceProgress;
    
    int                 currentStage;//平常的Stage ， 在去了stage3的时候 回来
    int                 currentMap;//平常的Stage ， 在去了stage3的时候 回来
    
    int isDoingNewHand1;
    
    int isDoingNewHand2;
    
    bool readyToSlip;
    
};

#endif /* defined(__runTileMap__GameScene__) */


