//
//  Gold.cpp
//  runTileMap
//
//  Created by Mac on 14-8-25.
//
//

#include "Gold.h"
#include "Player.h"
#include "GameData.h"

CGold::CGold()
{
    m_bAbosrb = false;
}

CGold::~CGold()
{
    
}

CGold* CGold::create(const char* pszFileName,int type)
{
    CGold* pGold = new CGold;
    if (pGold && pGold->initWithSpriteFrameName(pszFileName))
    {
        pGold->initItem(type);
        pGold->autorelease();
        return pGold;
    }
    CC_SAFE_DELETE(pGold);
	return NULL;
}

void CGold::initItem (int type)
{
    m_iGoldType = type;
    setAnchorPoint(CCPointZero);
    
    if (CGameData::getInstance()->getEffectEnable())
    {
        if (type >= 20)
        {
            m_pEffectSprite = CCSprite::create("blankpic.png");
            addChild(m_pEffectSprite);
            
            char szName[64] = {0};
            sprintf(szName, "Gold%d_Effect",m_iGoldType);
            CCAnimate* pAnim = CCAnimate::create(CCAnimationCache::sharedAnimationCache()->animationByName(szName));
            m_pEffectSprite->runAction(CCRepeatForever::create(pAnim));
        }
        else
        {
            char szName[64] = {0};
            sprintf(szName, "Gold_%d",m_iGoldType);
            CCAnimate* pAnim = CCAnimate::create(CCAnimationCache::sharedAnimationCache()->animationByName(szName));
            this->runAction(CCRepeatForever::create(pAnim));
        }
    }
    this->setScale(1.1f);
}

void CGold::update(CPlayer* player)
{
    if (m_bAbosrb)
    {
        double fAngle = ccpAngle(ccpNormalize(getPosition()),ccpNormalize(ccp(player->getPositionX(),player->getPositionY()+55))) / 3.1415926 * 180;
        float fDistance = 30;
        float fY = fDistance * sin(fAngle);
        float fX = fDistance * cos(fAngle);
        
        if (player->getPositionX() < getPositionX() &&
            player->getPositionY()+55 > getPositionY())
        {
            setPosition(ccp(getPositionX() - fX, getPositionY() + fY));
        }
        else if(player->getPositionX() < getPositionX() &&
                player->getPositionY()+55 < getPositionY())
        {
            setPosition(ccp(getPositionX() - fX, getPositionY() - fY));
        }
        else if (player->getPositionX() > getPositionX() &&
                 player->getPositionY()+55 > getPositionY())
        {
            setPosition(ccp(getPositionX() + fX, getPositionY() + fY));
        }
        else if(player->getPositionX() > getPositionX() &&
                player->getPositionY()+55 < getPositionY())
        {
            setPosition(ccp(getPositionX() + fX, getPositionY() - fY));
        }
    }
}