//
//  Item.cpp
//  runTileMap
//
//  Created by Mac on 14-8-25.
//
//

#include "Item.h"

CItem::CItem()
{
    m_pSubSprite = NULL;
}

CItem::~CItem()
{
    
}

CItem* CItem::create(const char* pszFileName,int type)
{
    CItem* pItem = new CItem;
    if (pItem && pItem->initWithSpriteFrameName(pszFileName))
    {
        pItem->initItem(type);
        pItem->autorelease();
        return pItem;
    }
    CC_SAFE_DELETE(pItem);
	return NULL;
}

void CItem::initItem (int type)
{
    m_iItemType = type;
    setAnchorPoint(CCPointZero);
        
    
    switch (m_iItemType)
    {
        case 1:
        {
            m_pEffectSprite = CCSprite::create("blankpic.png");
            CCAnimate* pAnim = CCAnimate::create(CCAnimationCache::sharedAnimationCache()->animationByName("Missile"));
            m_pEffectSprite->runAction(CCRepeatForever::create(pAnim));
            m_pEffectSprite->setAnchorPoint(CCPointZero);
            addChild(m_pEffectSprite,-1);
            
            CCSprite* pBubble = CCSprite::createWithSpriteFrameName("Item_Bubble.png");
            pBubble->setAnchorPoint(CCPointZero);
            addChild(pBubble, -2);            
            setScale(2);
        }
            break;
        case 2:
        {
            m_pEffectSprite = CCSprite::create("blankpic.png");
            CCAnimate* pAnim = CCAnimate::create(CCAnimationCache::sharedAnimationCache()->animationByName("Magnet"));
            m_pEffectSprite->runAction(CCRepeatForever::create(pAnim));
            m_pEffectSprite->setAnchorPoint(CCPointZero);
            addChild(m_pEffectSprite,-1);
            
            CCSprite* pBubble = CCSprite::createWithSpriteFrameName("Item_Bubble.png");
            pBubble->setAnchorPoint(CCPointZero);
            addChild(pBubble, -2);
            setScale(2);
        }
            break;
        case 3:
        {
            m_pEffectSprite = CCSprite::create("blankpic.png");
            CCAnimate* pAnim = CCAnimate::create(CCAnimationCache::sharedAnimationCache()->animationByName("Shell"));
            m_pEffectSprite->runAction(CCRepeatForever::create(pAnim));
            m_pEffectSprite->setAnchorPoint(CCPointZero);
            addChild(m_pEffectSprite,-1);
            
            CCSprite* pBubble = CCSprite::createWithSpriteFrameName("Item_Bubble.png");
            pBubble->setAnchorPoint(CCPointZero);
            addChild(pBubble, -2);
            setScale(2);
        }
            break;
        case 4:
        {
            m_pEffectSprite = CCSprite::create("blankpic.png");
            CCAnimate* pAnim = CCAnimate::create(CCAnimationCache::sharedAnimationCache()->animationByName("Battery"));
            m_pEffectSprite->runAction(CCRepeatForever::create(pAnim));
            m_pEffectSprite->setPosition(ccp(90, 50));
            addChild(m_pEffectSprite,1);
            
            m_pSubSprite = CCSprite::createWithSpriteFrameName("Item4_2.png");
            m_pSubSprite->setPosition(ccp(90, 50));
            addChild(m_pSubSprite,1);
            
            setScale(2);
        }
            break;
        case 5:
        {
            CCAnimate* pAnim = CCAnimate::create(CCAnimationCache::sharedAnimationCache()->animationByName("Portal"));
            this->runAction(CCRepeatForever::create(pAnim));
        }
            break;
    }
}

void CItem::getItem()
{
    removeChild(m_pSubSprite, true);
    removeChild(m_pEffectSprite, true);
    
    CCParticleSystemQuad* m_pEmitter = CCParticleSystemQuad::create("powerstation_corss.plist");
    this->addChild(m_pEmitter, 1);
    m_pEmitter->setPosition(ccp(290,80));
}

CCRect CItem::getCollectRect()
{
    if (m_iItemType == 4) {
        return CCRect(getPositionX()+250, getPositionY(), 20, 200);
    }
    else
    {
        return this->boundingBox();
    }
}
