//
//  ItemCell.cpp
//  runTileMap
//
//  Created by Mac on 14-9-16.
//
//

#include "ItemCell.h"
#include "CmySQLite.h"
#include "GameData.h"
#include "SoundManager.h"

#if (CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID) //判断当前是否为Android平台
#include "UtilFunc.h"
#endif

#include "baseSDKController.h"

CItemCell::CItemCell()
{
  
}

CItemCell::~CItemCell()
{

	CCScene * rscene = CCDirector::sharedDirector()->getRunningScene();
	rscene->removeChildByTag(212121);
		rscene->removeChildByTag(212121+1);
}

CItemCell* CItemCell::create(void* _data)
{
    CItemCell* pRect = new CItemCell;
    if (pRect && pRect->init())
    {
        pRect->setData(_data);
        pRect->initView();
        
        return pRect;
    }
    CC_SAFE_DELETE(pRect);
    return NULL;
}

void CItemCell::setData(void* _data)
{
    m_pItem = (ItemVO*)_data;
}

void CItemCell::initView()
{
    setAnchorPoint(CCPointZero);
    setContentSize(CCSizeMake(431, 78));
    CCSpriteFrameCache* cache = CCSpriteFrameCache::sharedSpriteFrameCache();
    
    CCSprite* pBG = CCSprite::createWithSpriteFrameName("ui_main_ItemCell.png");
    pBG->setAnchorPoint(CCPointZero);
    addChild(pBG);
    
    char szTexutre[128]={0};
    sprintf(szTexutre, "ui_main_Item%d.png", m_pItem->iID);
    CCSprite* pItem = CCSprite::createWithSpriteFrameName(szTexutre);
//    pItem->setAnchorPoint(CCPointZero);
    pItem->setPosition(ccp(40, 40));
    addChild(pItem);
    
    m_pDescriptionLabel = CCLabelTTF::create(m_pItem->szDescription.c_str(),"Arial-BoldMT",24,CCSizeMake(185, 60),
                                             kCCTextAlignmentLeft,kCCVerticalTextAlignmentCenter);
    m_pDescriptionLabel->setColor(ccc3(255, 255, 255));
    m_pDescriptionLabel->setPosition(ccp(185, 40));
    addChild(m_pDescriptionLabel);
    
    CCSprite* AmountSprite = CCSprite::createWithSpriteFrameName("ui-main-RedDot.png");
    AmountSprite->setPosition(ccp(70, 25));
    AmountSprite->setScale(0.9f);
    addChild(AmountSprite);
    
    m_pAmountLabel = CCLabelTTF::create("", "Arial-BoldMT", 24,CCSizeMake(85, 60),
                                        kCCTextAlignmentLeft,kCCVerticalTextAlignmentCenter);
    m_pAmountLabel->setColor(ccYELLOW);
    m_pAmountLabel->setPosition(ccp(58, 20 ));
    AmountSprite->addChild(m_pAmountLabel);
    
    
    char szText[64]={0};
    switch (m_pItem->iItemType) {
        case 1:
            sprintf(szText, "%d",m_pItem->iItemLevel);
            m_pAmountLabel->setString(szText);
            break;
        case 2:
            if (m_pItem->iID!=4 && m_pItem->iItemLevel>=10)
            {
                sprintf(szText, "MAX");
            }
            else if (m_pItem->iID ==4 && m_pItem->iItemLevel>=1)
            {
                sprintf(szText, "MAX");
            }
            else
            {
                sprintf(szText, "%d",m_pItem->iItemLevel+1);
            }
            m_pAmountLabel->setString(szText);
            break;
        default:
            break;
    }
    
    CCMenuItemImage* pBtn = CCMenuItemImage::create();
    pBtn->setNormalSpriteFrame(cache->spriteFrameByName("btn_main_purchase.png"));
    pBtn->setSelectedSpriteFrame(cache->spriteFrameByName("btn_main_purchase.png"));
    pBtn->initWithTarget(this, menu_selector(CItemCell::onConfirm));
    pBtn->setAnchorPoint(CCPointZero);
    pBtn->setPosition( ccp(290,8) );
    
    char szPrice[32]={0};
    sprintf(szPrice, "%d", m_pItem->iPrice);
    m_pPriceLabel = CCLabelTTF::create(szPrice, "Arial-BoldMT", 18,CCSizeMake(85, 60),
                                       kCCTextAlignmentLeft,kCCVerticalTextAlignmentCenter);
    m_pPriceLabel->setColor(ccc3(255, 255, 255));
    m_pPriceLabel->setPosition(ccp(80, 30 ));
    pBtn->addChild(m_pPriceLabel);
    
    CCSprite* pPurchaseSprite = CCSprite::createWithSpriteFrameName("btn_main_purchaseLabel.png");
    pPurchaseSprite->setAnchorPoint(ccp(0, 0));
    pPurchaseSprite->setPosition(ccp(5, 0));
    pBtn->addChild(pPurchaseSprite);
    
    CCMenu* pMenu = CCMenu::create(pBtn, NULL);
    pMenu->setAnchorPoint(CCPointZero);
    pMenu->setPosition( CCPointZero );
    addChild(pMenu, 1);
    
}
void  CItemCell::addAlert(CCObject* pSender)
{

	CBaseSDKController::sharedInstance()->alertMsg("You dont have enough money,go to buy some!! ");
	return;
	CCScene * rscene = CCDirector::sharedDirector()->getRunningScene();
	if(rscene->getChildByTag(212121))
	{
		return;
	}

	    	CCLabelTTF * noMoneyAlert = CCLabelTTF::create("You dont have enough money,go to buy some!! ","STHeiti TC",40);
	    	noMoneyAlert->setPosition(ccp(1280/2 , 720/2));

	    	CCLabelTTF * noMoneyAlert2 = CCLabelTTF::create("You dont have enough money,go to buy some!! ","STHeiti TC",40);
	    	noMoneyAlert2->setColor(ccBLACK);
	    	  noMoneyAlert2->setPosition(ccp(1280/2 +2 , 720/2 -2));
	    	alertTag = 212121;

	    	rscene->addChild(noMoneyAlert,alertTag + 100001 , 212121);
	    	rscene->addChild(noMoneyAlert2,alertTag + 100000 , 212121+1);

	    	CCDelayTime * deleyAct = CCDelayTime::create(2.0);
	    	CCCallFunc * callsa = CCCallFunc::create((CCObject*)this,callfunc_selector(CItemCell::closeAlert));
	    	this ->runAction(CCSequence::create(deleyAct,callsa , NULL));
}
void CItemCell::closeAlert(CCObject* pSender){

	CCScene * rscene = CCDirector::sharedDirector()->getRunningScene();
	rscene->removeChildByTag(212121);
	rscene->removeChildByTag(212121+1);
}


void CItemCell::onConfirm(CCObject* pSender)
{
    if (CGameData::getInstance()->getGold() < m_pItem->iPrice) {

 //   	CCNotificationCenter::sharedNotificationCenter()->postNotification("AddNoMoneyAlert",NULL);
    	addAlert(NULL);
        return;
    }
    
    CGameData::getInstance()->setGold(CGameData::getInstance()->getGold() - m_pItem->iPrice );
    
    if (m_pItem->iItemType == 1)
    {
        CSoundManager::getInstance()->playSound("sound/ui_buy_goods.OGG");
        switch (m_pItem->iID)
        {
            case 11:
                CGameData::getInstance()->setFood(CGameData::getInstance()->getFood() + 1);
                break;
            case 12:
                CGameData::getInstance()->setMedicalKit(CGameData::getInstance()->getMedicalKit() + 1);            
                break;
            case 13:
                CGameData::getInstance()->setShell(CGameData::getInstance()->getShell() + 1);
                break;
            case 14:
                CGameData::getInstance()->setPet1(CGameData::getInstance()->getPet1() + 1);
                break;
            case 15:
                CGameData::getInstance()->setPet2(CGameData::getInstance()->getPet2() + 1);
                break;
            case 16:
                CGameData::getInstance()->setPet3(CGameData::getInstance()->getPet3() + 1);
                break;
            default:
                break;
        }
        CGameData::getInstance()->updateData();
        CCNotificationCenter::sharedNotificationCenter()->postNotification("toShopList");

    }
    else if (m_pItem->iItemType == 2)
    {
        CSoundManager::getInstance()->playSound("sound/ui_level_up.OGG");
        switch (m_pItem->iID)
        {
            case 1:
                if (m_pItem->iItemLevel < 10)
                {
                    CGameData::getInstance()->setAbsrobLevel(m_pItem->iItemLevel + 1);
                    CGameData::getInstance()->updateData();
                    CCNotificationCenter::sharedNotificationCenter()->postNotification("toUpgrade");
                }
                break;
            case 2:
                if (m_pItem->iItemLevel < 10)
                {
                    CGameData::getInstance()->setAccelerateLevel(m_pItem->iItemLevel + 1);
                    CGameData::getInstance()->updateData();
                    CCNotificationCenter::sharedNotificationCenter()->postNotification("toUpgrade");
                }
                break;
            case 3:
                if (m_pItem->iItemLevel < 10)
                {
                    CGameData::getInstance()->setGiantLevel(m_pItem->iItemLevel + 1);
                    CGameData::getInstance()->updateData();
                    CCNotificationCenter::sharedNotificationCenter()->postNotification("toUpgrade");
                }
                break;
            case 4:
                if (m_pItem->iItemLevel < 1)
                {
                    CGameData::getInstance()->setPetLevel(m_pItem->iItemLevel + 1);
                    CGameData::getInstance()->updateData();
                    CCNotificationCenter::sharedNotificationCenter()->postNotification("toUpgrade");
                }
                break;
            default:
                break;
        }
    }
    
    
    
}
