//
//  ItemTable.cpp
//  runTileMap
//
//  Created by Mac on 14-9-17.
//
//

#include "ItemTable.h"
#include "ItemCell.h"
#include "SoundManager.h"

#include "GameData.h"
#include "GameModel.h"
#include "baseSDKController.h"

CItemTable::CItemTable()
{
    
}

CItemTable::~CItemTable()
{
    
}

CItemTable* CItemTable::create(void* _data)
{
    CItemTable* pRet = new CItemTable();
    
    if (pRet && pRet->init())
    {
        pRet->initView();
        pRet->setData(_data);
        //        pRet->autorelease();
        return pRet;
    }
    CC_SAFE_DELETE(pRet);
    return NULL;
}

void CItemTable::setData(void* _data)
{
    
    m_iListCount = 0;
    m_pItemList = CCTableView::create(this, CCSizeMake(445 , 385));//减去两边
    m_pItemList->setPosition(23 , 30);
    m_pListCan->addChild(m_pItemList);
    
    m_pItemList ->setDirection(kCCScrollViewDirectionVertical);
    m_pItemList->setVerticalFillOrder(kCCTableViewFillTopDown);
    m_pItemList ->setDelegate(this);
    
    if (_data == NULL) {
        return;
    }
    m_pItemArray = (CCArray*)_data;
    m_iListCount = m_pItemArray->count();
    m_pItemList->reloadData();
}

void CItemTable::updateData(void* _data)
{
//    m_pItemArray->removeAllObjects();
    if (_data == NULL) {
        m_iListCount = 0;
        m_pItemList->reloadData();
        return;
    }
    m_pItemArray = (CCArray*)_data;
    m_iListCount = m_pItemArray->count();
    m_pItemList->reloadData();
}

void CItemTable::initView()
{
    setAnchorPoint(CCPointZero);
    setContentSize(CCSizeMake(960, 640));
    
    CCSprite* pTableBody = CCSprite::createWithSpriteFrameName("ui_main_TableBody.png");
    pTableBody->setAnchorPoint(CCPointZero);
    pTableBody->setPosition(ccp(0,-30));
    addChild(pTableBody);
    
    m_pListCan = CCLayer::create();
    m_pListCan->setAnchorPoint(CCPointZero);
    m_pListCan->setContentSize(CCSizeMake(960, 640));
    addChild(m_pListCan);
    
//    CCSprite* pTableTop = CCSprite::createWithSpriteFrameName("ui_main_TableTop.png");
//    pTableTop->setAnchorPoint(CCPointZero);
//    pTableTop->setPosition(ccp(0,455));
//    addChild(pTableTop);
    

    CCMenuItemToggle* pShopItem = createToggle(menu_selector(CItemTable::toShopList),"btn_main_Shop.png","btn_main_ShopClick.png");
    pShopItem->setSelectedIndex(1);
    pShopItem->setAnchorPoint(ccp(0.5f,0.5f));
    pShopItem->setPosition( ccp(55,455) );
    pShopItem->setTag(1);
    pShopItem->setScale(1.4);

    CCMenuItemToggle* pEnchantItem = createToggle(menu_selector(CItemTable::toUpgrade),"btn_main_Enchant.png","btn_main_EnchantClick.png");
    pEnchantItem->setSelectedIndex(0);
    pEnchantItem->setAnchorPoint(ccp(0.5f,0.5f));
    pEnchantItem->setPosition( ccp(150,455) );
    pEnchantItem->setTag(2);
    pEnchantItem->setScale(1.4);

    CCMenuItemToggle* pAchievementItem = createToggle(menu_selector(CItemTable::toAchievementList),"btn_main_Achievement.png","btn_main_AchievementClick.png");
    pAchievementItem->setSelectedIndex(0);
    pAchievementItem->setAnchorPoint(ccp(0.5f,0.5f));
    pAchievementItem->setPosition( ccp(240,455) );
    pAchievementItem->setTag(3);
    pAchievementItem->setScale(1.4);
    
    CCMenuItemToggle* pQuestItem = createToggle(menu_selector(CItemTable::toQuest),"btn_main_Quest.png","btn_main_QuestClick.png");
    pQuestItem->setSelectedIndex(0);
    pQuestItem->setAnchorPoint(ccp(0.5f,0.5f));
    pQuestItem->setPosition( ccp(330,455) );
    pQuestItem->setTag(4);
    pQuestItem->setScale(1.4);
    
    pMenu = CCMenu::create(pShopItem,pEnchantItem ,pAchievementItem,  pQuestItem, NULL);
    pMenu->setAnchorPoint(CCPointZero);
    pMenu->setPosition( ccp(5, 0) );
    addChild(pMenu, 2);
    
    pTagSprite = CCSprite::createWithSpriteFrameName("ui_main_shopTag.png");
    pTagSprite->setAnchorPoint(ccp(0.5, 0.5));
    pTagSprite->setPosition(ccp(58,455));
    addChild(pTagSprite);
    
    lAchieveQuestcan = CCLayer::create();
    addChild(lAchieveQuestcan);
}

CCSize CItemTable::cellSizeForTable(CCTableView *table)
{
    return CCSizeMake(431, 70);
}

void CItemTable::tableCellTouched(CCTableView* table, CCTableViewCell* cell)
{
    
}

CCTableViewCell* CItemTable::tableCellAtIndex(CCTableView *table, unsigned int idx)
{
    CCTableViewCell * cell = table->dequeueCell();

    if (!cell)
    {
        ItemVO * pItem = (ItemVO * )m_pItemArray->objectAtIndex(idx);
        cell = CItemCell::create(pItem);
        cell ->setTag(idx + 1000);
        return cell;
    }
    else
    {
        ItemVO * pItem = (ItemVO * )m_pItemArray->objectAtIndex(idx);
        cell = CItemCell::create(pItem);
        cell ->setTag(idx + 1000);
        return cell;
    }
}

unsigned int CItemTable::numberOfCellsInTableView(CCTableView *table)
{
    return m_iListCount;
}

CCMenuItemToggle* CItemTable::createToggle(SEL_MenuHandler selector, char * fileNameNormal, char * fileNameSelect)
{
    CCSpriteFrameCache* cache = CCSpriteFrameCache::sharedSpriteFrameCache();
    
    CCMenuItemImage* imgNormal = CCMenuItemImage::create();
    imgNormal->setNormalSpriteFrame(cache->spriteFrameByName(fileNameNormal));
    CCMenuItemImage* imgSelect = CCMenuItemImage::create();
    imgSelect->setNormalSpriteFrame(cache->spriteFrameByName(fileNameSelect));
    CCMenuItemToggle* imgToggle = CCMenuItemToggle::createWithTarget(this, selector, imgNormal, imgSelect, NULL);
    return imgToggle;
}

void CItemTable::toShopList(CCObject* pSender)
{
    CSoundManager::getInstance()->playSound("sound/ui_button.ogg");
    
    
    lAchieveQuestcan ->removeAllChildren();
    
    toShowBtn(1);
    CCMenuItemToggle* pToggle = (CCMenuItemToggle*)pSender;
    pToggle->setSelectedIndex(1);
    
    
    CCNotificationCenter::sharedNotificationCenter()->postNotification("toShopList");
    
    pTagSprite->setPosition(ccp(58,455));
}

void CItemTable::toUpgrade(CCObject* pSender)
{
   CSoundManager::getInstance()->playSound("sound/ui_button.ogg");
    
    lAchieveQuestcan ->removeAllChildren();
    
    toShowBtn(2);
    CCMenuItemToggle* pToggle = (CCMenuItemToggle*)pSender;
    pToggle->setSelectedIndex(1);
    
    
    CCNotificationCenter::sharedNotificationCenter()->postNotification("toUpgrade");
    
    pTagSprite->setPosition(pToggle->getPosition());
}

void CItemTable::toAchievementList(CCObject* pSender)
{
    
    
    toShowBtn(3);
    CCLog("toAchievementList");
    CCMenuItemToggle* pToggle = (CCMenuItemToggle*)pSender;
    pToggle->setSelectedIndex(1);
    
    
    lAchieveQuestcan ->removeAllChildren();
    
    CCNotificationCenter::sharedNotificationCenter()->postNotification("toAchievementList");
    
    pTagSprite->setPosition(pToggle->getPosition());
    
    showAchievement();
}

void CItemTable::toQuest(CCObject * pSender)
{
    
    toShowBtn(4);
    CCMenuItemToggle* pToggle = (CCMenuItemToggle*)pSender;
    pToggle->setSelectedIndex(1);
    
    
    lAchieveQuestcan ->removeAllChildren();
    
    CCNotificationCenter::sharedNotificationCenter()->postNotification("toQuest");
    
    pTagSprite->setPosition(pToggle->getPosition());
    
    showQuest();
}

void CItemTable::toShowBtn(int btnTag)
{
    ((CCMenuItemToggle*)pMenu->getChildByTag(1))->setSelectedIndex(0);
    ((CCMenuItemToggle*)pMenu->getChildByTag(2))->setSelectedIndex(0);
    ((CCMenuItemToggle*)pMenu->getChildByTag(3))->setSelectedIndex(0);
    ((CCMenuItemToggle*)pMenu->getChildByTag(4))->setSelectedIndex(0);
}



void  CItemTable::showAchievement()
{
    
    CCLayer * can = CCLayer::create();
    lAchieveQuestcan -> addChild(can);
    for(int i= 1 ; i< 7 ; i++)
    {
        char strAch[256] = {'\0'};
        sprintf(strAch, "ui_main_achieveItem%d.png",i);
        
        CCSprite * achieveSp  = CCSprite::createWithSpriteFrameName(strAch);
        can->addChild(achieveSp);
        if (i<4) {
            achieveSp->setPosition(ccp(97 + (i-1)*148, 340));
        }else{
            achieveSp->setPosition(ccp(97 + (i-4)*148, 160));
        }
        
        if (i > GameModel::getInstance()->iAchieveReach ) {
            CCSprite * cover = CCSprite::createWithSpriteFrameName("ui_main_achieveItem_cover.png");
            can->addChild(cover);
            cover->setPosition(achieveSp->getPosition());
        }
    }
}

void CItemTable::showQuest()
{
    
    
    CCSprite * can = CCSprite::createWithSpriteFrameName("ui_quest_bg.png");
    can->setAnchorPoint(ccp(0, 0));
     lAchieveQuestcan -> addChild(can);
    can->setPosition(ccp(17, 30));
    
    int itemY = 300;
    
    int itemY2 = 300 - 160;
    
    int fontsize = 20;
    
    CCSpriteFrameCache* cache = CCSpriteFrameCache::sharedSpriteFrameCache();
    
    CCLabelTTF * task1Label = CCLabelTTF::create("task 1: Download UC Browser","Arial-BoldMT" ,fontsize );
    task1Label->setAnchorPoint(ccp(0, 0.5));
    task1Label->setPosition(ccp(50, itemY));
    task1Label->setColor(ccc3(0, 0, 100));
    can -> addChild(task1Label);
    
    CCSprite * rewardCan1 = CCSprite::createWithSpriteFrameName("ui_quest_rewardBg.png");
    rewardCan1->setAnchorPoint(ccp(0, 0));
    rewardCan1->setPosition(ccp(70 ,itemY - 82));
    can -> addChild(rewardCan1);
    
    CCLabelTTF * rewardLabel1 = CCLabelTTF::create("bonus：     X10000", "Arial-BoldMT", fontsize-1);
    rewardLabel1 ->setAnchorPoint(ccp(0, 0));
    rewardLabel1->setPosition(ccp(15,5));
    rewardLabel1->setColor(ccc3(0, 0, 100));
    rewardCan1->addChild(rewardLabel1);
    
    CCSprite * gold1 = CCSprite::createWithSpriteFrameName("ui_main_gold.png");
    gold1->setPosition(ccp(102, 20));
    gold1->setScale(0.8);
    rewardCan1 ->addChild(gold1);
    
    CCMenuItemImage *buyBtn1 ;
    
    if (GameModel::getInstance()->isMission1ok()) {
        CCLabelTTF * buyBtnText1 = CCLabelTTF::create("received", "STHeiti TC", fontsize);
        buyBtnText1->setAnchorPoint(ccp(0.5,0.5));
        buyBtnText1->setPosition(ccp(342, itemY - 82 + 25));
        buyBtnText1->setColor(ccc3(0, 0, 100));
        can -> addChild(buyBtnText1);
    }else{
        buyBtn1 = CCMenuItemImage::create();
        buyBtn1->setNormalSpriteFrame(cache->spriteFrameByName("buybtn.png"));
        buyBtn1->setSelectedSpriteFrame(cache->spriteFrameByName("buybtn_click.png"));
        buyBtn1->initWithTarget(this, menu_selector(CItemTable::reward1) );
        buyBtn1->setPosition(ccp(342, itemY - 82 + 25));
        
        CCLabelTTF * buyBtnText1 = CCLabelTTF::create("receive", "STHeiti TC", fontsize);
        buyBtnText1->setAnchorPoint(ccp(0.5,0.5));
        buyBtnText1->setPosition(ccp(50, 35));
        buyBtn1 -> addChild(buyBtnText1);
    }
    
    
    
    
    
    //第二任务
    CCLabelTTF * task2Label = CCLabelTTF::create("task 2: Share to Facebook","Arial-BoldMT" ,fontsize);
    task2Label->setAnchorPoint(ccp(0, 0.5));
    task2Label->setPosition(ccp(50, itemY2));
    task2Label->setColor(ccc3(0, 0, 100));
    can -> addChild(task2Label);
    
    CCSprite * rewardCan2 = CCSprite::createWithSpriteFrameName("ui_quest_rewardBg.png");
    rewardCan2->setAnchorPoint(ccp(0, 0));
    rewardCan2->setPosition(ccp(70 ,itemY2 - 82));
    can -> addChild(rewardCan2);
    
    CCLabelTTF * rewardLabel2 = CCLabelTTF::create("bonus：     X2000", "Arial-BoldMT", fontsize-1);
    rewardLabel2 ->setAnchorPoint(ccp(0, 0));
    rewardLabel2->setPosition(ccp(15,5));
    rewardLabel2->setColor(ccc3(0, 0, 100));
    rewardCan2->addChild(rewardLabel2);
    
    CCSprite * gold2 = CCSprite::createWithSpriteFrameName("ui_main_gold.png");
    gold2->setPosition(ccp(102, 20));
    rewardCan2 ->addChild(gold2);
    gold2->setScale(0.8);
    
    CCMenuItemImage *buyBtn2 = CCMenuItemImage::create();
    buyBtn2->setNormalSpriteFrame(cache->spriteFrameByName("buybtn.png"));
    buyBtn2->setSelectedSpriteFrame(cache->spriteFrameByName("buybtn_click.png"));
    buyBtn2->initWithTarget(this, menu_selector(CItemTable::reward2) );
    buyBtn2->setPosition(ccp(342, itemY2 - 82 + 25));
    
    CCLabelTTF * buyBtnText2 = CCLabelTTF::create("receive", "STHeiti TC", 20);
    buyBtnText2->setAnchorPoint(ccp(0.5,0.5));
    buyBtnText2->setPosition(ccp(50, 35));
    buyBtn2 -> addChild(buyBtnText2);
    
    CCMenu * pBuyMenu;
    if (GameModel::getInstance()->isMission1ok()) {
        pBuyMenu = CCMenu::create(  buyBtn2, NULL);
    }else{
        pBuyMenu = CCMenu::create( buyBtn1  , buyBtn2, NULL);
    }
    
    pBuyMenu->setAnchorPoint(CCPointZero);
    pBuyMenu->setPosition( ccp(0, 0) );
    
    can->addChild(pBuyMenu, 2);
    
}


void CItemTable::reward1(CCObject * pSender)
{

    if (GameModel::getInstance()->isMission1ok()) {
    	return;
    }
    GameModel::getInstance()->mission1ok();
    CGameData::getInstance()->gainGold( 10000);
    CBaseSDKController::sharedInstance()->openDownUCURL();
    CBaseSDKController::sharedInstance()->umSendEvent("downloadUcBrower", "");
}
void CItemTable::reward2(CCObject * pSender)
{
    
    //CGameData::getInstance()->gainGold(  10000);
    
    
    char mmsg[256]={0};
	sprintf(mmsg , "Ha, I'm the fastest runner! I scored %d points from the #UCBrowser Crazy City Run. I bet you can't beat me! Would you like to try? @UC Browser", CGameData::getInstance()->getTopScore());
    CBaseSDKController::sharedInstance()->shareToFacebook(mmsg);
}
