//
//  MainScene.cpp
//  runTileMap
//
//  Created by Mac on 14-9-15.
//
//

#include "MainScene.h"

#include "SoundManager.h"
#include "GameData.h"
#include "ItemVO.h"
#include "Player.h"
#include "Pet.h"

using namespace cocos2d;

#include "GameScene.h"
#include "CmySQLite.h"
#include "GameData.h"
#include "SettingLayer.h"
#include "SoundManager.h"
#include "BuyGoldLayer.h"
#include "BuyHeartLayer.h"
#include "GameModel.h"

#include "BaseSDKController.h"

CMainScene::CMainScene()
{
}

CMainScene::~CMainScene()
{
}

CCScene* CMainScene::scene()
{
    CCScene *scene = CCScene::create();
    CMainScene *layer = CMainScene::create();
    scene->addChild(layer);
    return scene;
}

// on "init" you need to initialize your instance
bool CMainScene::init()
{
    if ( !CCLayer::init() )
    {
        return false;
    }
    

    GameModel::getInstance()->init();
    if (GameModel::getInstance()->isJustOpen) {
        
        GameModel::getInstance()->isJustOpen = false;
        
        CCSprite * facePic = CCSprite::create("ucrunface.jpg");
                facePic ->setAnchorPoint(ccp(0.5, 0.5));
                facePic ->setScale(CGameData::getInstance()->getScreenSize().height/640.f);

                facePic->setPosition(ccp(CGameData::getInstance()->getScreenSize().width * 0.5f,
                                         CGameData::getInstance()->getScreenSize().height * 0.5f));
                addChild(facePic,1234567,1234567);

        CCSprite * facePic9 = CCSprite::create("9game.jpg");
        facePic9 ->setAnchorPoint(ccp(0.5, 0.5));
        facePic9 ->setScale(CGameData::getInstance()->getScreenSize().height/480.f);
        
        facePic9->setPosition(ccp(CGameData::getInstance()->getScreenSize().width * 0.5f,
                                 CGameData::getInstance()->getScreenSize().height * 0.5f));
        addChild(facePic9,12345678,12345678);
        
        
        this->schedule( schedule_selector(CMainScene::removeFacePic), 3.0 );
    }
    

    string writablePath = CCFileUtils::sharedFileUtils()->getWritablePath();
    char szText[64]={0};

    CCSpriteFrameCache* cache = CCSpriteFrameCache::sharedSpriteFrameCache();
    cache->addSpriteFramesWithFile("Item.plist");
    cache->addSpriteFramesWithFile("UIMain.plist");
    cache->addSpriteFramesWithFile("UCCharacter.plist");
    cache->addSpriteFramesWithFile("Pet2.plist");
    
//    CmySQLite::getInstance()->openDataBase(writablePath.c_str(),"RunData.db", &m_db_DataBase);
    
    CCSprite* pBG = CCSprite::create("UI_main_BG.jpg");
    pBG->setScale(7);
    pBG->setPosition(ccp(CGameData::getInstance()->getScreenSize().width * 0.5f,
                         CGameData::getInstance()->getScreenSize().height * 0.5f));
    addChild(pBG);
    
    //---开始层
    CCLayer* pGameStart_Layer = CCLayer::create();
    pGameStart_Layer->setAnchorPoint(CCPointZero);
    pGameStart_Layer->setPosition(ccp(900, 90));
    addChild(pGameStart_Layer);
    
    //历史
    sprintf(szText, "Farthest Distance:%d", CGameData::getInstance()->getTopRunDistance());
    CCLabelTTF* pTopDistanceLabel = CCLabelTTF::create(szText, "Arial-BoldMT",20,CCSizeMake(800, 48),kCCTextAlignmentLeft);
    pTopDistanceLabel->setPosition(ccp(280, 490));
    pGameStart_Layer->addChild(pTopDistanceLabel,1);
    
    sprintf(szText, "Top Score:%d", CGameData::getInstance()->getTopScore());
    CCLabelTTF* pTopScoreLabel = CCLabelTTF::create(szText, "Arial-BoldMT",20,CCSizeMake(800, 48),kCCTextAlignmentLeft);
    pTopScoreLabel->setPosition(ccp(280, 460));
    pGameStart_Layer->addChild(pTopScoreLabel,1);
    
    sprintf(szText, "Top Score This Week:%d", CGameData::getInstance()->getWeekTopScore());
    CCLabelTTF* pWeekTopScoreLabel = CCLabelTTF::create(szText, "Arial-BoldMT",22,CCSizeMake(800, 48),kCCTextAlignmentLeft);
    pWeekTopScoreLabel->setPosition(ccp(280, 430));
    pGameStart_Layer->addChild(pWeekTopScoreLabel,1);
    
    sprintf(szText, "Top Score Last Week:%d", CGameData::getInstance()->getLastWeekTopScore());
    CCLabelTTF* pLastWeekTopScoreLabel = CCLabelTTF::create(szText, "Arial-BoldMT",20,CCSizeMake(800, 48),kCCTextAlignmentLeft);
    pLastWeekTopScoreLabel->setPosition(ccp(280, 390));
    pGameStart_Layer->addChild(pLastWeekTopScoreLabel,1);
    
    CCMenuItemImage *pStartItem = CCMenuItemImage::create();
    pStartItem->setNormalSpriteFrame(cache->spriteFrameByName("btn_main_start.png"));
    pStartItem->setSelectedSpriteFrame(cache->spriteFrameByName("btn_main_start.png"));
    pStartItem->initWithTarget(this, menu_selector(CMainScene::menuStartCallback) );
    pStartItem->setPosition( ccp(0,15) );
    
    CCSprite* pStartSprite = CCSprite::createWithSpriteFrameName("btn_main_startLabel.png");
    pStartSprite->setAnchorPoint(ccp(0, 0));
    pStartItem->addChild(pStartSprite);
    
    CCMenu* pMenu = CCMenu::create(pStartItem, NULL);
    pMenu->setAnchorPoint(CCPointZero);
    pMenu->setPosition( CCPointZero );
    pGameStart_Layer->addChild(pMenu, 1);

    CCSprite* pThreatreSprite = CCSprite::createWithSpriteFrameName("ui_main_theatre.png");
    pThreatreSprite->setPosition(ccp(0, 230));
    pGameStart_Layer->addChild(pThreatreSprite);
    
    //主角
    std::vector<string> Action_Vector;
	std::vector<float>	Delay_Vector;
    
    Action_Vector.push_back("Run_");
    Delay_Vector.push_back(0.03);
    Action_Vector.push_back("TailRun_");
    Delay_Vector.push_back(0.07);
    Action_Vector.push_back("EyesRun_");
    Delay_Vector.push_back(0.07);
    
    CPlayer* m_pPlayer = CPlayer::createPlayer("Character1_");
    m_pPlayer->setData("Character1", 1, 3, 0.025, 10);
    m_pPlayer->initAnimation(Action_Vector, Delay_Vector, 15);
    pGameStart_Layer->addChild(m_pPlayer,Player_Z);
    m_pPlayer->setAnchorPoint(ccp(0.5f,0.4f));
    m_pPlayer->playAction("Run_");
    m_pPlayer->setPosition(ccp(-20,150));
    
    //宠物
    if(CGameData::getInstance()->getPetLevel())
    {
        Action_Vector.push_back("Run_");
        Delay_Vector.push_back(0.04);
        
        Action_Vector.push_back("TailRun_");
        Delay_Vector.push_back(0.03);
        
        Action_Vector.push_back("EyesRun_");
        Delay_Vector.push_back(0.07);
        
        CPet* m_pPet = CPet::createPet("Pet2_",Action_Vector, Delay_Vector, 15, AirType);
        m_pPet->playAction("Run_");
        m_pPet->setPosition(ccp(-20,250));
        m_pPet->setOriginalPosition(ccp(-20,250));
        pGameStart_Layer->addChild(m_pPet);
    }
    
    //---头顶层
    CCLayer* pHeader_Layer = CCLayer::create();
    pHeader_Layer->setPosition(ccp(640, 620));
    addChild(pHeader_Layer);
    

    CCLabelTTF *versionlab = CCLabelTTF::create("v3.0", "Arial-BoldMT",28,CCSizeMake(100, 48),kCCTextAlignmentLeft);
    versionlab->setPosition(ccp(-460, 0));
    pHeader_Layer->addChild(versionlab, UI_Z);

    CCMenuItemImage *pAddHeartItem = CCMenuItemImage::create();
    pAddHeartItem->setNormalSpriteFrame(cache->spriteFrameByName("btn_main_add.png"));
    pAddHeartItem->setSelectedSpriteFrame(cache->spriteFrameByName("btn_main_add.png"));
    pAddHeartItem->initWithTarget(this, menu_selector(CMainScene::menuBuyHeart) );
    pAddHeartItem->setPosition( ccp(-280,0) );
    
    CCMenuItemImage *pAddGoldItem = CCMenuItemImage::create();
    pAddGoldItem->setNormalSpriteFrame(cache->spriteFrameByName("btn_main_add.png"));
    pAddGoldItem->setSelectedSpriteFrame(cache->spriteFrameByName("btn_main_add.png"));
    pAddGoldItem->initWithTarget(this, menu_selector(CMainScene::menuBuyGold) );
    pAddGoldItem->setPosition( ccp(50,0) );
    
    CCMenuItemImage *pOptionItem = CCMenuItemImage::create();
    pOptionItem->setNormalSpriteFrame(cache->spriteFrameByName("btn_main_setting.png"));
    pOptionItem->setSelectedSpriteFrame(cache->spriteFrameByName("btn_main_setting.png"));
    pOptionItem->initWithTarget(this, menu_selector(CMainScene::menuOptionCallback) );
    pOptionItem->setPosition( ccp(420,0) );
    
    CCMenu* pHeaderMenu = CCMenu::create(pAddHeartItem, pAddGoldItem, pOptionItem, NULL);
    pHeaderMenu->setAnchorPoint(CCPointZero);
    pHeaderMenu->setPosition( ccp(0, 0) );
    pHeader_Layer->addChild(pHeaderMenu, 2);
    
    CCSprite* pHeartBG = CCSprite::createWithSpriteFrameName("ui_main_GoldBG.png");
    pHeartBG->setAnchorPoint(ccp(0, 0.5));
    pHeartBG->setPosition(ccp(-445,0));
    pHeader_Layer->addChild(pHeartBG, 1);
    
    CCSprite* pHeartSprite = CCSprite::createWithSpriteFrameName("ui_main_heart.png");
    pHeartSprite->setAnchorPoint(ccp(0, 0.5));
    pHeartSprite->setPosition(ccp(-435,0));
    pHeader_Layer->addChild(pHeartSprite, 1);
    
//    m_pHeartSprite = CCSprite::createWithSpriteFrameName("ui_main_heart.png");
//    m_pHeartSprite->setAnchorPoint(ccp(0, 0.5));
//    m_pHeartSprite->setPosition(ccp(200,600));
//    addChild(m_pHeartSprite, UI_Z + 1);
    
    
    sprintf(szText, "%d", CGameData::getInstance()->getHeart());
    m_pHeartLabel = CCLabelTTF::create(szText, "Arial-BoldMT",28,CCSizeMake(100, 48),kCCTextAlignmentLeft);
    m_pHeartLabel->setPosition(ccp(120, 20));
    pHeartBG->addChild(m_pHeartLabel,1);
    
    
    CCSprite* pGoldBG = CCSprite::createWithSpriteFrameName("ui_main_GoldBG.png");
    pGoldBG->setAnchorPoint(ccp(0, 0.5));
    pGoldBG->setPosition(ccp(-140,0));
    pHeader_Layer->addChild(pGoldBG, 1);
    
    CCSprite* pGoldSprite = CCSprite::createWithSpriteFrameName("ui_main_gold.png");
    pGoldSprite->setAnchorPoint(ccp(0, 0.5));
    pGoldSprite->setPosition(ccp(-135,0));
    pHeader_Layer->addChild(pGoldSprite, 1);
    
    sprintf(szText, "%d", CGameData::getInstance()->getGold());
    m_pGoldLabel = CCLabelTTF::create(szText, "Arial-BoldMT",28,CCSizeMake(200, 48),kCCTextAlignmentLeft);
    m_pGoldLabel->setPosition(ccp(170, 20));
    pGoldBG->addChild(m_pGoldLabel,1);
    
    //---道具层
    m_pItemTable = CItemTable::create(NULL);
    m_pItemTable->setContentSize(CCSizeMake(445, 465));
    m_pItemTable->setPosition(ccp(190,80));
    this->addChild(m_pItemTable);
    
    toShopList(NULL);
    
    this->setScale(1.15f);
    
    CSoundManager::getInstance()->setMusicOn(CGameData::getInstance()->getMusicEnable());
    CSoundManager::getInstance()->setSoundOn(CGameData::getInstance()->getSoundEnable());
    CSoundManager::getInstance()->playMusic("sound/bkg.OGG");
    

	 CBaseSDKController::sharedInstance()->start9gameAds();

    this->schedule( schedule_selector(CMainScene::updateGame), 1.0 );
    
    

    return true;
}

void CMainScene::onEnter()
{
    CCLayer::onEnter();
    CCNotificationCenter::sharedNotificationCenter()->addObserver(this,
                                                                  callfuncO_selector(CMainScene::toShopList),
                                                                  "toShopList",
                                                                  NULL);
    
    CCNotificationCenter::sharedNotificationCenter()->addObserver(this,
                                                                  callfuncO_selector(CMainScene::toUpgrade),
                                                                  "toUpgrade",
                                                                  NULL);
    CCNotificationCenter::sharedNotificationCenter()->addObserver(this,
                                                                  callfuncO_selector(CMainScene::toAchievementList),
                                                                  "toAchievementList",
                                                                  NULL);
    CCNotificationCenter::sharedNotificationCenter()->addObserver(this,
                                                                  callfuncO_selector(CMainScene::toQuestList),
                                                                  "toQuest",
                                                                  NULL);
    
    CCNotificationCenter::sharedNotificationCenter()->addObserver(this,
                                                                  callfuncO_selector(CMainScene::showItemTable),
                                                                  "showItemTable",
                                                                  NULL);
//    CCNotificationCenter::sharedNotificationCenter()->addObserver(this, callfuncO_selector(CMainScene::updateDataShow), "updateData", NULL);
    
}

void CMainScene::onExit()
{
    CCLayer::onExit();
    CCNotificationCenter::sharedNotificationCenter()->removeObserver(this,"toShopList");
    CCNotificationCenter::sharedNotificationCenter()->removeObserver(this,"toUpgrade");
    CCNotificationCenter::sharedNotificationCenter()->removeObserver(this,"toAchievementList");
    CCNotificationCenter::sharedNotificationCenter()->removeObserver(this,"toQuest");
    CCNotificationCenter::sharedNotificationCenter()->removeObserver(this,"showItemTable");
//    CCNotificationCenter::sharedNotificationCenter()->removeObserver(this,"updateData");
    

}

void CMainScene::menuCloseCallback(CCObject* pSender)
{
    CCDirector::sharedDirector()->end();
    
#if (CC_TARGET_PLATFORM == CC_PLATFORM_IOS)
    exit(0);
#endif
}


void CMainScene::menuStartCallback(CCObject* pSender)
{
//    ccBezierConfig  beziercofig;
//    beziercofig.controlPoint_1 = ccp(200, 600);
//    beziercofig.controlPoint_2 = ccp( 1000, 400);
//    beziercofig.endPosition = ccp(900, 190);
//    m_pHeartSprite->runAction(CCBezierTo::create(1.5, beziercofig));
    
	 CBaseSDKController::sharedInstance()->over9gameAds();

    CGameData::getInstance()->subOneHeartCnt();
    
    CSoundManager::getInstance()->playSound("sound/ui_readygo.ogg");
    
    CCScene* scene = CCScene::create();
    CGameScene* layer = CGameScene::create();
    scene->addChild(layer);
    CCDirector::sharedDirector()->replaceScene(scene);
}

void CMainScene::menuOptionCallback(CCObject* pSender)
{
    CSoundManager::getInstance()->playSound("sound/ui_button.ogg");
    
    removeChild(m_pItemTable);
    
    CSettingLayer* pSettingLayer = CSettingLayer::create();
    pSettingLayer->setPosition(ccp(260,100));
    pSettingLayer->setScale(1.1f);
    this->addChild(pSettingLayer);
}

void CMainScene::menuBuyHeart(CCObject * pSender)
{
    CSoundManager::getInstance()->playSound("sound/ui_button.ogg");
    
    removeChild(m_pItemTable);
    
    CBuyHeartLayer* pBuyHeartLayer = CBuyHeartLayer::create();
    pBuyHeartLayer->setPosition(ccp(260,230));
    pBuyHeartLayer->setScale(1.1f);
    this->addChild(pBuyHeartLayer);
}

void CMainScene::menuBuyGold(CCObject * pSender)
{
    CSoundManager::getInstance()->playSound("sound/ui_button.ogg");
    
    removeChild(m_pItemTable);
    
    CBuyGoldLayer* pBuyGoldLayer = CBuyGoldLayer::create();
    pBuyGoldLayer->setPosition(ccp(260,230));
    pBuyGoldLayer->setScale(1.1f);
    this->addChild(pBuyGoldLayer);
}

void CMainScene::toShopList(CCObject* pSender)
{
    CSoundManager::getInstance()->playSound("sound/ui_button.ogg");
    
    m_pItemTable->updateData(CGameData::getInstance()->getConsumableArray());
    
    char szText[64]={0};
    sprintf(szText, "%d", CGameData::getInstance()->getGold());
    m_pGoldLabel->setString(szText);
}

void CMainScene::toUpgrade(CCObject* pSender)
{
    CSoundManager::getInstance()->playSound("sound/ui_button.ogg");
    
    m_pItemTable->updateData(CGameData::getInstance()->getUpgradesArray());
    
    char szText[64]={0};
    sprintf(szText, "%d", CGameData::getInstance()->getGold());
    m_pGoldLabel->setString(szText);
}

void CMainScene::toQuestList(CCObject* pSender)
{
    
    CSoundManager::getInstance()->playSound("sound/ui_button.ogg");
    m_pItemTable->updateData(NULL);
}

void CMainScene::toAchievementList(CCObject* pSender)
{
    
    CSoundManager::getInstance()->playSound("sound/ui_button.ogg");
    m_pItemTable->updateData(NULL);
}

void CMainScene::showItemTable(CCObject* pSender)
{
    m_pItemTable = CItemTable::create(NULL);
    m_pItemTable->setContentSize(CCSizeMake(445, 465));
    m_pItemTable->setPosition(ccp(190,80));
    this->addChild(m_pItemTable);
    
    toShopList(NULL);
}

void CMainScene::updateDataShow(CCObject * psender)
{
    char szText[64] = {'\0'};
    sprintf(szText, "%d", CGameData::getInstance()->getGold());
    m_pGoldLabel ->setString( szText );
    sprintf(szText, "%d", CGameData::getInstance()->getHeartCnt());
    m_pHeartLabel ->setString( szText );
}

void CMainScene::updateGame()
{
	char strMsg[256] = {'\0'};
	int nHeartTime = CGameData::getInstance()->getHeartWaitTime();
	int nHeartCnt = CGameData::getInstance()->getHeartCnt();
    sprintf(strMsg,"%d",nHeartCnt);
    m_pHeartLabel->setString(strMsg);

    updateDataShow(NULL);
}

void CMainScene::removeFacePic()
{
    if (getChildByTag(12345678)) {
        removeChildByTag(12345678);
        
        
    }else{
    	if (getChildByTag(1234567)) {
    	        removeChildByTag(1234567);

    	        this->unschedule( schedule_selector(CMainScene::removeFacePic) );

    	}
    }
}
