//
//  Partner.cpp
//  runTileMap
//
//  Created by Mac on 14-8-29.
//
//

#include "Partner.h"
#include "Player.h"
#include "CharacterVO.h"

CPartner::CPartner()
{
    CharacterInfo_Array = NULL;
    
    m_bAttatch = false;
    
    m_fMoveDistance = 0;
}

CPartner::~CPartner()
{
    
}

CPartner* CPartner::createPartner(string szName,vector<string> szAction,vector<float> delay, int max_frame)
{
    CPartner* pPartner = new CPartner;
    if (pPartner && pPartner->init())
    {
        pPartner->initPartner(szName, szAction, delay, max_frame);
        pPartner->autorelease();
        return pPartner;
    }
    CC_SAFE_DELETE(pPartner);
    return NULL;
}

void CPartner::initPartner(string szName,vector<string> szAction,vector<float> delay, int max_frame)
{
    m_szSpriteName = szName;
    CCArray *animFrames = CCArray::create();
	string szframeName;
	string szActionName;
    
	for(int i=0;i<szAction.size();i++)
	{
        animFrames->removeAllObjects();
        
        //创建动画每一帧，从cache里面读取
        char str[3] = {0};
        for(int j = 1; j <max_frame; j++)
        {
            sprintf(str, "%d", j);
            szframeName = m_szSpriteName + szAction[i] + str + ".png";
            CCSpriteFrame* frame = CCSpriteFrameCache::sharedSpriteFrameCache()->spriteFrameByName( szframeName.c_str() );
            if(!frame) break;
            animFrames->addObject(frame);
        }
        szActionName = m_szSpriteName + szAction[i];
        CCAnimation* animation = CCAnimation::createWithSpriteFrames(animFrames,delay[i]);
        CCAnimationCache::sharedAnimationCache()->addAnimation(animation, szActionName.c_str());
	}
    
    this->setAnchorPoint(ccp(0.5f, 0.2f));
    
    CharacterInfo_Array = CCArray::create();
    CharacterInfo_Array->retain();
    
    m_pTailSprite = CCSprite::createWithSpriteFrameName("Character2_TailFall_1.png");
    m_pTailSprite->setPosition(ccp(112, 100));
    addChild(m_pTailSprite,-1);
    
    m_pEyesSprite = CCSprite::createWithSpriteFrameName("Character2_EyesRun_1.png");
    m_pEyesSprite->setPosition(ccp(112, 100));
    m_pEyesSprite->setVisible(false);
    addChild(m_pEyesSprite,2);

}

void CPartner::playAction(string szActing, bool bRepeat)
{
    this->stopActionByTag(1);
    
    string szBodyAction;
    szBodyAction = m_szSpriteName + szActing;
	if(bRepeat)
	{
        CCAction* act = CCRepeatForever::create(CCAnimate::create(CCAnimationCache::sharedAnimationCache()
                                                                  ->animationByName(szBodyAction.c_str())));
        act->setTag(1);
		this->runAction(act);
	}
	else
	{
        CCAction* act = CCAnimate::create(CCAnimationCache::sharedAnimationCache()
                                          ->animationByName(szBodyAction.c_str()));
        act->setTag(1);
		this->runAction(act);
	}
    
    if (szActing == "Jump_") {
        m_pEyesSprite->setVisible(false);
    }
    
    if (szActing == "Fall_") {
        m_pEyesSprite->setVisible(false);
    }
        
    if (szActing == "Roll_") {
        m_pTailSprite->cocos2d::CCNode::setVisible(false);
        m_pTailSprite->stopAllActions();
        m_pEyesSprite->setVisible(false);
    }
    else
    {
        string szTailAction = m_szSpriteName + "Tail" + szActing;
        CCAnimate* animTail = NULL;
        animTail = CCAnimate::create(CCAnimationCache::sharedAnimationCache()->animationByName(szTailAction.c_str()));
        CCAction* actTail = CCRepeatForever::create(animTail);
        m_pTailSprite->setVisible(true);
        m_pTailSprite->stopAllActions();
        m_pTailSprite->runAction(actTail);
    }
    
    if (szActing == "Run_")
    {
        m_pEyesSprite->setVisible(true);
        string szTailAction = m_szSpriteName + "Eyes" + szActing;
        CCAction* actEyes = NULL;
        actEyes = CCRepeatForever::create( CCSequence::create(
                                                              CCAnimate::create(
                                                                                CCAnimationCache::sharedAnimationCache()
                                                                                ->animationByName(szTailAction.c_str())),
                                                              CCDelayTime::create(2),
                                                              NULL) );
        m_pEyesSprite->stopAllActions();
        m_pEyesSprite->runAction(actEyes);
        
        m_pEyesSprite->setPosition(ccp(112, 101));
        CCAction* actMoveEyes = CCRepeatForever::create( CCSequence::create(
                                                                            CCMoveBy::create(0.03, ccp(0, -2)),
                                                                            CCMoveBy::create(0.03, ccp(0, -2)),
                                                                            CCMoveBy::create(0.03, ccp(0, +2)),
                                                                            CCMoveBy::create(0.03, ccp(0, +2)),
                                                                            CCMoveBy::create(0.03, ccp(0, 0)),
                                                                            CCMoveBy::create(0.03, ccp(0, 0)),
                                                                            CCMoveBy::create(0.03, ccp(0, -2)),
                                                                            CCMoveBy::create(0.03, ccp(0, -2)),
                                                                            CCMoveBy::create(0.03, ccp(0, +2)),
                                                                            CCMoveBy::create(0.03, ccp(0, +2)),
                                                                            CCMoveBy::create(0.03, ccp(0, 0)),
                                                                            CCMoveBy::create(0.03, ccp(0, 0)),
                                                                            NULL));
        m_pEyesSprite->runAction(actMoveEyes);
    }
    
    if (szActing == "Slip_")
    {
        m_pEyesSprite->setVisible(true);
        string szTailAction = m_szSpriteName + "Eyes" + szActing;
        CCAction* actEyes = NULL;
        actEyes =CCRepeatForever::create(  CCSequence::create(CCAnimate::create(
                                                                                CCAnimationCache::sharedAnimationCache()
                                                                                ->animationByName(szTailAction.c_str())),
                                                              CCDelayTime::create(2),
                                                              NULL)) ;
        m_pEyesSprite->stopAllActions();
        m_pEyesSprite->runAction(actEyes);
    }

}

void CPartner::update (CPlayer* pPlayer)
{
    if (m_bAttatch)
    {
        m_fMoveDistance += 10;
        if (m_fMoveDistance > 3000) {
            m_bAttatch = false;
        }
        if (CharacterInfo_Array->count() < 15)
        {
            CCharacterVO* pCharacterVO = new CCharacterVO;

            pCharacterVO->setCharacterAction(pPlayer->getPlayerAction());
            pCharacterVO->setCharacterPosition(pPlayer->getPosition());
            
            CharacterInfo_Array->addObject(pCharacterVO);
        }
        else
        {
            CharacterInfo_Array->removeObjectAtIndex(0);
            
            CCharacterVO* pNewCharacterVO = new CCharacterVO;
            pNewCharacterVO->setCharacterAction(pPlayer->getPlayerAction());
            pNewCharacterVO->setCharacterPosition(pPlayer->getPosition());
            
            CharacterInfo_Array->addObject(pNewCharacterVO);
            
            this->setPosition(((CCharacterVO*)CharacterInfo_Array->objectAtIndex(1))->getCharacterPosition());
            
            if (((CCharacterVO*)CharacterInfo_Array->objectAtIndex(1))->getCharacterAction() != ((CCharacterVO*)CharacterInfo_Array->objectAtIndex(0))->getCharacterAction())
            {
                string szAction;
                switch (((CCharacterVO*)CharacterInfo_Array->objectAtIndex(1))->getCharacterAction()) {
                    case kActionMoving:
                        playAction("Run_");
                        break;
                    case kActionJumping:
                        playAction("Jump_",false);
                        break;
                    case kActionFalling:
                        playAction("Fall_",false);
                        break;
                    case kActionDoubleJumping:
                        playAction("Roll_",false);
                        break;
                    case kActionSliping:
                        playAction("Slip_",false);
                        break;
                    default:
                        break;
                }
            }
        }
    }
}