//
//  PauseLayer.cpp
//  runTileMap
//
//  Created by Mac on 14-10-14.
//
//

#include "PauseLayer.h"

#include "ScoreScene.h"
#include "SoundManager.h"


CPauseLayer::CPauseLayer()
{
}

CPauseLayer::~CPauseLayer()
{
    
}


bool CPauseLayer::init()
{
    if(CCLayer::create())
	{
		CCSprite* pBGSprite = CCSprite::createWithSpriteFrameName("UIGame_PauseBG.png");
        pBGSprite->setAnchorPoint(CCPointZero);
        pBGSprite->setPosition(ccp(0, 0));
        addChild(pBGSprite);
        
        CCSprite* pTextSprite = CCSprite::createWithSpriteFrameName("UIGame_PauseText.png");
        pTextSprite->setAnchorPoint(CCPointZero);
        pTextSprite->setPosition(ccp(0, 0));
        addChild(pTextSprite);
        
        CCSpriteFrameCache* cache = CCSpriteFrameCache::sharedSpriteFrameCache();
        
        CCMenuItemImage *pContinueItem = CCMenuItemImage::create();
        pContinueItem->setNormalSpriteFrame(cache->spriteFrameByName("btn_game_Continue.png"));
        pContinueItem->setSelectedSpriteFrame(cache->spriteFrameByName("btn_game_ContinueClick.png"));
        pContinueItem->initWithTarget(this, menu_selector(CPauseLayer::resumeGame) );
        pContinueItem->setPosition( ccp(100,100) );
        CCSprite* pContinueSprite = CCSprite::createWithSpriteFrameName("txt_game_Continue.png");
        pContinueSprite->setAnchorPoint(CCPointZero);
        pContinueItem->addChild(pContinueSprite);
        
        CCMenuItemImage *pQuitItem = CCMenuItemImage::create();
        pQuitItem->setNormalSpriteFrame(cache->spriteFrameByName("btn_game_Continue.png"));
        pQuitItem->setSelectedSpriteFrame(cache->spriteFrameByName("btn_game_ContinueClick.png"));
        pQuitItem->initWithTarget(this, menu_selector(CPauseLayer::quitGame) );
        pQuitItem->setPosition( ccp(350,100) );
        CCSprite* pQuitSprite = CCSprite::createWithSpriteFrameName("txt_game_End.png");
        pQuitSprite->setAnchorPoint(CCPointZero);
        pQuitItem->addChild(pQuitSprite);
        
        CCMenu* pMenu = CCMenu::create(pContinueItem, pQuitItem, NULL);
        pMenu->setAnchorPoint(CCPointZero);
        pMenu->setPosition( ccp(0, 0) );
        addChild(pMenu, 2);
        
        setTouchEnabled(true);
        
        return true;
	}
    else
    {
        return false;
    }
}

void CPauseLayer::resumeGame(CCObject* pSender)
{
    CSoundManager::getInstance()->playSound("sound/ui_button.ogg");
    
    CCNotificationCenter::sharedNotificationCenter()->postNotification("resumeGame");
    
    this->removeFromParentAndCleanup(true);
    
}

void CPauseLayer::quitGame(CCObject* pSender)
{
   CSoundManager::getInstance()->playSound("sound/ui_button.ogg");
    
    CCScene* scene = CCScene::create();
    CScoreScene* layer = CScoreScene::create();
    scene->addChild(layer);
    CCDirector::sharedDirector()->replaceScene(scene);
    
    CCDirector::sharedDirector()->resume();
}

void CPauseLayer::registerWithTouchDispatcher()
{
    CCDirector::sharedDirector()->getTouchDispatcher()->addTargetedDelegate(this, kCCMenuHandlerPriority, true);
    CCLayer::registerWithTouchDispatcher();
}

bool CPauseLayer::ccTouchBegan (cocos2d::CCTouch *pTouch, cocos2d::CCEvent *pEvent)
{
    return true;
}

void CPauseLayer::ccTouchMoved (cocos2d::CCTouch *pTouch, cocos2d::CCEvent *pEvent)
{
    
}

void CPauseLayer::ccTouchEnded (cocos2d::CCTouch *pTouch, cocos2d::CCEvent *pEvent)
{
    
}

