//
//  Pet.cpp
//  runTileMap
//
//  Created by Mac on 14-10-13.
//
//

#include "Pet.h"

CPet::CPet()
{
    CharacterInfo_Array = NULL;
}

CPet::~CPet()
{
    
}

CPet* CPet::createPet(string szName,vector<string> szAction,vector<float> delay, int max_frame, int iType)
{
    CPet* pPet = new CPet;
    if (pPet && pPet->init())
    {
        pPet->initPet(szName, szAction, delay, max_frame, iType);
        pPet->autorelease();
        return pPet;
    }
    CC_SAFE_DELETE(pPet);
    return NULL;
}

void CPet::initPet(string szName,vector<string> szAction,vector<float> delay, int max_frame, int iType)
{
    m_szSpriteName = szName;
    CCArray *animFrames = CCArray::create();
	string szframeName;
	string szActionName;
    
	for(int i=0;i<szAction.size();i++)
	{
        animFrames->removeAllObjects();
        
        //创建动画每一帧，从cache里面读取
        char str[3] = {0};
        for(int j = 1; j <max_frame; j++)
        {
            sprintf(str, "%d", j);
            szframeName = m_szSpriteName + szAction[i] + str + ".png";
            CCSpriteFrame* frame = CCSpriteFrameCache::sharedSpriteFrameCache()->spriteFrameByName( szframeName.c_str() );
            if(!frame) break;
            animFrames->addObject(frame);
        }
        szActionName = m_szSpriteName + szAction[i];
        CCAnimation* animation = CCAnimation::createWithSpriteFrames(animFrames,delay[i]);
        CCAnimationCache::sharedAnimationCache()->addAnimation(animation, szActionName.c_str());
	}
    
    m_pTailSprite = CCSprite::create("blankpic.png");
    m_pTailSprite->setPosition(ccp(100, 60));
    addChild(m_pTailSprite,-1);
    
    m_pEyesSprite = CCSprite::create("blankpic.png");
    m_pEyesSprite->setPosition(ccp(105, 60));
    m_pEyesSprite->setVisible(false);
    addChild(m_pEyesSprite,2);
    
    this->setZOrder(1);
    
    CharacterInfo_Array = CCArray::create();
    CharacterInfo_Array->retain();
    
    if (iType == AirType)
    {
        m_vOriginalPosition = ccp(600,300);
        schedule(schedule_selector(CPet::fly), 5);
    }
}

void CPet::playAction(string szActing, bool bRepeat)
{
    this->stopActionByTag(1);
	string szAction = m_szSpriteName + szActing;
	if(bRepeat)
	{
        CCAction* act = CCRepeatForever::create(CCAnimate::create(CCAnimationCache::sharedAnimationCache()
                                                                  ->animationByName(szAction.c_str())));
        act->setTag(1);
		this->runAction(act);
	}
	else
	{
        CCAction* act = CCAnimate::create(CCAnimationCache::sharedAnimationCache()
                                          ->animationByName(szAction.c_str()));
        act->setTag(1);
		this->runAction(act);
	}
    
    string szTailAction = m_szSpriteName + "Tail" + szActing;
    CCAction* actTail = NULL;
    actTail = CCRepeatForever::create(CCAnimate::create(CCAnimationCache::sharedAnimationCache()
                                                        ->animationByName(szTailAction.c_str())));
    if (actTail) {
        m_pTailSprite->setVisible(true);
        m_pTailSprite->stopAllActions();
        m_pTailSprite->runAction(actTail);
    }
    else
    {
        m_pTailSprite->cocos2d::CCNode::setVisible(false);
        m_pTailSprite->stopAllActions();
    }
    
    m_pEyesSprite->setVisible(true);
    string szEyesAction = m_szSpriteName + "Eyes" + szActing;
    CCAction* actEyes = NULL;
    actEyes = CCRepeatForever::create( CCSequence::create(
                                                          CCAnimate::create(
                                                                            CCAnimationCache::sharedAnimationCache()
                                                                            ->animationByName(szEyesAction.c_str())),
                                                          CCDelayTime::create(2),
                                                          NULL) );
    m_pEyesSprite->stopAllActions();
    m_pEyesSprite->runAction(actEyes);
}

void CPet::update (CPlayer* pPlayer)
{
    
}

void CPet::fly()
{
    float fDifX = CCRANDOM_0_1() * 200 - 100;
    float fDifY = CCRANDOM_0_1() * 200 - 100;
    
    runAction(CCMoveTo::create(1, ccp(m_vOriginalPosition.x + fDifX, m_vOriginalPosition.y + fDifY)));
}