//
//  RoadBlock.cpp
//  MyRun
//
//  Created by Mac on 14-8-5.
//
//

#include "RoadBlock.h"
#include "Player.h"
#include "Bullet.h"
#include "GameData.h"

CRoadBlock::CRoadBlock()
{
    _bActivate = true;
}

CRoadBlock::~CRoadBlock()
{
    pBulletArray->removeAllObjects();
    CC_SAFE_DELETE(pBulletArray);
}

CRoadBlock* CRoadBlock::create(const char* pszFileName, int type, int subType)
{
    CRoadBlock* pRoadBlock = new CRoadBlock;
    if (pRoadBlock && pRoadBlock->initWithSpriteFrameName(pszFileName))
    {
        pRoadBlock->initRoadBlock(type, subType);
        pRoadBlock->autorelease();
        return pRoadBlock;
    }
    CC_SAFE_DELETE(pRoadBlock);
    
	return NULL;
}

void CRoadBlock::initRoadBlock (int type,int subType)
{
    _iType = type;
    _iSubType = subType;
    pBulletArray = CCArray::create();
    pBulletArray->retain();
    switch (_iType)
    {
        case 1:
        {
            CCAnimate* pAnim = CCAnimate::create(CCAnimationCache::sharedAnimationCache()->animationByName("RoadBlock1_"));
            this->runAction(CCRepeatForever::create(pAnim));
        }
            break;
        case 2:
        {
            CCAnimate* pAnim = CCAnimate::create(CCAnimationCache::sharedAnimationCache()->animationByName("RoadBlock2_"));
            this->runAction(CCRepeatForever::create(pAnim));
        }
            break;
        case 3:
            _bActivate = false;
            break;
        case 4:
        {
            _bActivate = false;
            
            CCSprite* pEffectSprite = CCSprite::create("blankpic.png");
            addChild(pEffectSprite, -1);
            CCAnimate* pAnim = CCAnimate::create(CCAnimationCache::sharedAnimationCache()->animationByName("Bullet1_"));
            pEffectSprite->runAction(CCRepeatForever::create(pAnim));
            
            switch (_iSubType) {
                case 1:
                    pEffectSprite->setPosition(ccp(60, 40));
                    break;
                case 2:
                    pEffectSprite->setPosition(ccp(60, 40));
                    this->setScale(2);
                    break;
                case 3:
                    pEffectSprite->setPosition(ccp(400, 150));
                    pEffectSprite->setScale(3);
                    break;
                default:
                    break;
            }
        }
            break;
        case 5:
        {
            CCAnimate* pAnim = CCAnimate::create(CCAnimationCache::sharedAnimationCache()->animationByName("RoadBlock5_"));
            this->runAction(CCRepeatForever::create(pAnim));
            
            CCSprite* pDrill = CCSprite::createWithSpriteFrameName("RoadBlock5_Drill1.png");
            CCAnimate* pAnim2 = CCAnimate::create(CCAnimationCache::sharedAnimationCache()->animationByName("RoadBlock5_Drill"));
            pDrill->runAction(CCRepeatForever::create(pAnim2));
            pDrill->setAnchorPoint(ccp(0,0));
            this->addChild(pDrill,-1);
        }
        default:
            break;
    }
    setAnchorPoint(ccp(0, 0.1));
}

void CRoadBlock::removeRoadBlock(CCObject* pSender)
{
    getParent()->removeChild((CCSprite*)pSender);
}

void CRoadBlock::update(CPlayer* player)
{
    switch (_iType)
    {
        case 3:
        {
            if (!_bActivate &&
                getPositionX()-player->getPositionX() > 400 &&
                getPositionX()-player->getPositionX() < 450)
            {
                _bActivate = true;
            }
        }
            break;
        case 4:
        {
            if (!_bActivate &&
                getPositionX()-player->getPositionX() > 600 &&
                getPositionX()-player->getPositionX() < 2000)
            {
                _bActivate = true;
            }
            
            if (_bActivate) {
                setPositionX(getPositionX()-10);
                
//                if (getCollisionRect().intersectsRect(player->getCollisionRect()) &&
//                    !player->getTakingDamage())
//                {
//                    player->takeDamage(1,4);
//                }
            }
            else if(getPositionX()-player->getPositionX() < -200)
            {
                _bActivate = false;
            }
        }
            break;
        default:
            break;
    }
    
    if(player->getCollisionRect().intersectsRect(getCollisionRect()))
    {
        if (player->getIsGiant())
        {
//            switch (_iType)
//            {
//                case 3:
//                {
////                    stopAllActions();
////                    CCAnimate* pAnim = CCAnimate::create(CCAnimationCache::sharedAnimationCache()->animationByName("RoadBlockCollapse3_"));
////                    this->runAction(pAnim);
//                }
//                    break;
//                case 4:
//                {
////                    stopAllActions();
////                    CCAnimate* pAnim = CCAnimate::create(CCAnimationCache::sharedAnimationCache()->animationByName("RoadBlockCollapse4_"));
////                    this->runAction(pAnim);
//                }
//                    break;
//                default:
//                    break;
//            }
            this->runAction(CCMoveBy::create(8, ccp(900, 800)));
            this->runAction(CCRepeatForever::create(CCRotateBy::create(0.35, 360)));
        }
        else if (!player->getTakingDamage())
        {
            switch (_iType) {
                case 1:
                {
//                    stopAllActions();
//                    CCAnimate* pAnim = CCAnimate::create(CCAnimationCache::sharedAnimationCache()->animationByName("RoadBlockCollapse1_"));
//                    this->runAction(CCSequence::create(pAnim,
//                                                       CCCallFuncN::create(this, callfuncN_selector(CRoadBlock::removeRoadBlock)),
//                                                       NULL) );
                    player->takeDamage(1,1);
                }
                    break;
                case 2:
                {
//                    stopAllActions();
//                    CCAnimate* pAnim = CCAnimate::create(CCAnimationCache::sharedAnimationCache()->animationByName("RoadBlockCollapse2_"));
//                    this->runAction(CCSequence::create(pAnim,
//                                                       CCCallFuncN::create(this, callfuncN_selector(CRoadBlock::removeRoadBlock)),
//                                                       NULL) );
                    
                    player->takeDamage(1,2);
                    
                }
                    break;
                case 3:
                {
                    stopAllActions();
                    CCAnimate* pAnim = CCAnimate::create(CCAnimationCache::sharedAnimationCache()->animationByName("RoadBlockCollapse3_"));
                    this->runAction(CCSequence::create(pAnim,
                                                       CCCallFuncN::create(this, callfuncN_selector(CRoadBlock::removeRoadBlock)),
                                                       NULL) );
                    player->slowDown(4);
                }
                    break;
                case 4:
                {
                    player->takeDamage(1,4);
                }
                    break;
                case 5:
                {
                    player->takeDamage(1,5);
                }
                default:
                    break;
            }
        }
    }
}


void CRoadBlock::collDown(CCObject* pSender)
{
    _bActivate = false;
}


CCRect CRoadBlock::getCollisionRect()
{
    switch (_iType)
    {
        case 1:
            return CCRect(this->getPositionX(), this->getPositionY() + getContentSize().height * 0.1f, 100, 100);
            break;
        case 2:
            return CCRect(this->getPositionX(), this->getPositionY() + getContentSize().height * 0.1f, 64, 250);
            break;
        case 3:
            return CCRect(this->getPositionX() + getContentSize().width*0.3f, this->getPositionY() + getContentSize().height * 0.1f, 100, 100);
            break;
        case 4:
//            return CCRect(this->getPositionX() + getContentSize().width*0.1f, this->getPositionY() + getContentSize().height * 0.1f, 100, 100);
            return CCRect(getPositionX() + getContentSize().width*.01f, getPositionY(), getContentSize().width*0.8f, getContentSize().height);
            break;
        case 5:
            return CCRect(this->getPositionX(), this->getPositionY(), 64, 400);
        default:
            break;
    }
}
