//
//  ScoreScene.cpp
//  runTileMap
//
//  Created by Mac on 14-10-24.
//
//

#include "ScoreScene.h"

#include "MainScene.h"

#include "BaseSDKController.h"

CScoreScene::CScoreScene()
{
}

CScoreScene::~CScoreScene()
{
}

CCScene* CScoreScene::scene()
{
    CCScene *scene = CCScene::create();
    CScoreScene *layer = CScoreScene::create();
    scene->addChild(layer);
    return scene;
}

// on "init" you need to initialize your instance
bool CScoreScene::init()
{
    if ( !CCLayer::init() )
    {
        return false;
    }

    CGameData::getInstance()->setGold(CGameData::getInstance()->getGold() + CGameData::getInstance()->getGainGold());
    CGameData::getInstance()->updateData();
    CGameData::getInstance()->updateScore();
    
    char szText[32]={0};
    
    int screenW = CGameData::getInstance()->getScreenSize().width;
    int screenY = CGameData::getInstance()->getScreenSize().height;
    
    CCSprite* pBG = CCSprite::create("UI_main_BG.jpg");
    pBG->setScale(7);
    pBG->setPosition(ccp(CGameData::getInstance()->getScreenSize().width * 0.5f,
                         CGameData::getInstance()->getScreenSize().height * 0.5f));
    addChild(pBG);
    
    CCSprite* pLight = CCSprite::createWithSpriteFrameName("ui_score_Light.png");
    pLight->setAnchorPoint(CCPointZero);
    pLight->setScale(3.2);
    addChild(pLight);
    
    CCSprite* pBGSprite = CCSprite::createWithSpriteFrameName("ui_score_Body.png");
    pBGSprite->setAnchorPoint(CCPointZero);
    pBGSprite->setPosition(ccp(200, 150));
    addChild(pBGSprite);
    
    int midWidth = pBGSprite->getContentSize().width/2;
    
    CCSprite* pTitleSprite = CCSprite::createWithSpriteFrameName("ui_score_Header.png");
    
    pTitleSprite->setPosition(ccp(midWidth, 380));
    pBGSprite->addChild(pTitleSprite);
    
    CCSprite* pHeaderSprite = CCSprite::createWithSpriteFrameName("ui_score_title.png");
    
    pHeaderSprite->setPosition(ccp(midWidth, 400));
    pBGSprite->addChild(pHeaderSprite);
    
    CCSprite* pTopScoreSprite = CCSprite::createWithSpriteFrameName("ui_score_Rect1.png");
    
    pTopScoreSprite->setPosition(ccp(midWidth, 300));
    pBGSprite->addChild(pTopScoreSprite);
    
    
    sprintf(szText, "Top Score:%d",CGameData::getInstance()->getTopScore());
    CCLabelTTF* pTopScoreLabel = CCLabelTTF::create(szText, "Arial-BoldMT",25,CCSizeMake(260, 48),kCCTextAlignmentCenter);
    pTopScoreLabel->setPosition(ccp(pTopScoreSprite->getContentSize().width/2, 16));
    pTopScoreSprite->addChild(pTopScoreLabel);
    
    CCLabelTTF * pSoreLab = CCLabelTTF::create("Score","Arial-BoldMT",30 ,CCSizeMake(100, 48),kCCTextAlignmentLeft);
    pSoreLab->setPosition(ccp(midWidth - 100, 240) );
    pBGSprite->addChild(pSoreLab);
    
    sprintf(szText, "%d",CGameData::getInstance()->getRunScore());
    CCLabelTTF* pScoreLabel = CCLabelTTF::create(szText, "Arial-BoldMT",45,CCSizeMake(260, 48),kCCTextAlignmentCenter);

    pScoreLabel->setColor(ccYELLOW);
    pScoreLabel->setPosition(ccp(midWidth + 30, 240));
    pBGSprite->addChild(pScoreLabel);
    
    
    CCSprite* pScoreSprite = CCSprite::createWithSpriteFrameName("ui_score_Rect2.png");
    pScoreSprite->setAnchorPoint(CCPointZero);
    pScoreSprite->setPosition(ccp(33, 33));
     pBGSprite->addChild(pScoreSprite);
    
    sprintf(szText, "Distance:%d",CGameData::getInstance()->getRunDistance());
    CCLabelTTF* pDistanceLabel = CCLabelTTF::create(szText, "Arial-BoldMT",28,CCSizeMake(320, 48),kCCTextAlignmentCenter);
    pDistanceLabel->setColor(ccc3(0, 0, 100));
    pDistanceLabel->setPosition(ccp(150, 90));
    pScoreSprite->addChild(pDistanceLabel);
    
    CCSprite * goldsp = CCSprite::createWithSpriteFrameName("ui_score_Gold.png");
    goldsp->setPosition(ccp(130, 50));
    pScoreSprite -> addChild(goldsp);
    
    
    sprintf(szText, "%d",CGameData::getInstance()->getGainGold());
    CCLabelTTF* pGoldLabel = CCLabelTTF::create(szText, "Arial-BoldMT",28);
    pGoldLabel->setAnchorPoint(ccp(0, 0));
    pGoldLabel->setColor(ccc3(0, 0, 100));
    pGoldLabel->setPosition(ccp(170, 40));
    pScoreSprite->addChild(pGoldLabel);
    
    
    CCSpriteFrameCache* cache = CCSpriteFrameCache::sharedSpriteFrameCache();
    CCMenuItemImage *pCloseItem = CCMenuItemImage::create();
    pCloseItem->setNormalSpriteFrame(cache->spriteFrameByName("btn_score_Return.png"));
    pCloseItem->setSelectedSpriteFrame(cache->spriteFrameByName("btn_score_Return.png"));
    pCloseItem->initWithTarget(this, menu_selector(CScoreScene::menuCloseCallback) );
    pCloseItem->setPosition( ccp(screenW/3,80) );
    
    CCLabelTTF* m_pCloseLabel = CCLabelTTF::create("Back", "Arial-BoldMT",35,CCSizeMake(120, 48),kCCTextAlignmentCenter);
    m_pCloseLabel->setPosition(ccp(130, 60));
    pCloseItem->addChild(m_pCloseLabel,1);
    
    CCMenuItemImage *pCloseItem2 = CCMenuItemImage::create();
    pCloseItem2->setNormalSpriteFrame(cache->spriteFrameByName("btn_score_Share.png"));
    pCloseItem2->setSelectedSpriteFrame(cache->spriteFrameByName("btn_score_Share.png"));
    pCloseItem2->initWithTarget(this, menu_selector(CScoreScene::menuShareCallback) );
    pCloseItem2->setPosition( ccp(screenW*2/3,80) );
    
    CCLabelTTF* m_pCloseLabel2 = CCLabelTTF::create("Share", "Arial-BoldMT",35,CCSizeMake(120, 48),kCCTextAlignmentCenter);
    m_pCloseLabel2->setPosition(ccp(130, 60));
    pCloseItem2->addChild(m_pCloseLabel2,1);
    
    CCMenu* pMenu = CCMenu::create(pCloseItem,pCloseItem2, NULL);
    pMenu->setAnchorPoint(CCPointZero);
    pMenu->setPosition( ccp(0, 0) );
    addChild(pMenu, 2);
    
    CCSprite* pCharacterSprite = CCSprite::createWithSpriteFrameName("ui_main_ScoreCharacter.png");
    pCharacterSprite->setPosition(ccp(880, 350));
    addChild(pCharacterSprite);
    
    
    
    //星星
    int mWidth = pBGSprite->getContentSize().width/2;
    if (CGameData::getInstance()->getGainGold() > 100) {
        CCSprite * star = CCSprite::createWithSpriteFrameName("ui_score_Stars.png");
        pBGSprite -> addChild(star);
        star ->setPosition(ccp(mWidth - 100, 463));
        star->setRotation(-20);
    }
    if (CGameData::getInstance()->getGainGold() >200) {
        CCSprite * star = CCSprite::createWithSpriteFrameName("ui_score_Stars.png");
        pBGSprite -> addChild(star);
        star ->setPosition(ccp(mWidth, 473));
    }
    if (CGameData::getInstance()->getGainGold() >500) {
        CCSprite * star = CCSprite::createWithSpriteFrameName("ui_score_Stars.png");
        pBGSprite -> addChild(star);
        star ->setPosition(ccp(mWidth + 100, 463));
        star->setRotation(20);
    }
    
    
    CBaseSDKController::sharedInstance()->umSendEvent("getInTheGameOverPage", "");
    
    return true;
}

void CScoreScene::onEnter()
{
    CCLayer::onEnter();
}

void CScoreScene::onExit()
{
    CCLayer::onExit();
}

void CScoreScene::menuCloseCallback(CCObject* pSender)
{
    CCScene* scene = CCScene::create();
    CMainScene* layer = CMainScene::create();
    scene->addChild(layer);
    CCDirector::sharedDirector()->replaceScene(scene);
    
    CCDirector::sharedDirector()->resume();
}

void CScoreScene::menuShareCallback(CCObject* pSender)
{

    char mmsg[256]={0};
	sprintf(mmsg , "Ha, I'm the fastest runner! I scored %d points from the #UCBrowser Crazy City Run. I bet you can't beat me! Would you like to try? @UC Browser",CGameData::getInstance()->getRunScore());
    CBaseSDKController::sharedInstance()->shareToFacebook(mmsg);
}

