//
//  SoundManager.cpp
//  runTileMap
//
//  Created by Mac on 14-10-20.
//
//

#include "SoundManager.h"

#include "SimpleAudioEngine.h"


CSoundManager* CSoundManager::m_pInstance = NULL;

CSoundManager::CSoundManager()
{
    m_nMusicOn = true;
    m_nSoundOn = true;
}

CSoundManager::~CSoundManager()
{
    
}

CSoundManager* CSoundManager::getInstance()
{
    if (!m_pInstance)
	{
		m_pInstance = new CSoundManager();
		m_pInstance->init();
	}
    
	return m_pInstance;
}

bool CSoundManager::init()
{
    CocosDenshion::SimpleAudioEngine::sharedEngine() ->preloadEffect(CCFileUtils::sharedFileUtils()->fullPathForFilename("sound/get_gold.ogg").c_str());
    CocosDenshion::SimpleAudioEngine::sharedEngine() ->preloadEffect(CCFileUtils::sharedFileUtils()->fullPathForFilename("sound/role_jump.ogg").c_str());
    CocosDenshion::SimpleAudioEngine::sharedEngine() ->preloadEffect(CCFileUtils::sharedFileUtils()->fullPathForFilename("sound/role_jump_big.ogg").c_str());
    CocosDenshion::SimpleAudioEngine::sharedEngine() ->preloadEffect(CCFileUtils::sharedFileUtils()->fullPathForFilename("sound/ui_button.ogg").c_str());
    CocosDenshion::SimpleAudioEngine::sharedEngine() ->preloadEffect(CCFileUtils::sharedFileUtils()->fullPathForFilename("sound/rush.ogg").c_str());
    CocosDenshion::SimpleAudioEngine::sharedEngine() ->preloadEffect(CCFileUtils::sharedFileUtils()->fullPathForFilename("sound/door_cross.ogg").c_str());
    CocosDenshion::SimpleAudioEngine::sharedEngine() ->preloadEffect(CCFileUtils::sharedFileUtils()->fullPathForFilename("sound/ui_buy_goods.OGG").c_str());
    CocosDenshion::SimpleAudioEngine::sharedEngine() ->preloadEffect(CCFileUtils::sharedFileUtils()->fullPathForFilename("sound/ui_level_up.OGG").c_str());
    CocosDenshion::SimpleAudioEngine::sharedEngine() ->preloadEffect(CCFileUtils::sharedFileUtils()->fullPathForFilename("sound/ui_readygo.ogg").c_str());
    CocosDenshion::SimpleAudioEngine::sharedEngine() ->preloadEffect(CCFileUtils::sharedFileUtils()->fullPathForFilename("sound/UCfast.mp3").c_str());
    
    
	return true;
}

void CSoundManager::setMusicOn(int nFlag)
{
	m_nMusicOn = nFlag;
//	setGameData();
	if (!nFlag)
	{
		stopMusic();
	}
	else if (strlen(m_strMusicFile) > 0)
	{
		playMusic(m_strMusicFile);
	}
    
	playSound("sound/switch.mp3");
}

void CSoundManager::setSoundOn(int nFlag)
{
	m_nSoundOn = nFlag;
//	setGameData();
    
	playSound("sound/switch.mp3");
}

void CSoundManager::playMusic(const char* strFileName)
{
    strcpy(m_strMusicFile, strFileName);
    
	if (!m_nMusicOn)
	{
		return;
	}
	CocosDenshion::SimpleAudioEngine::sharedEngine()->playBackgroundMusic(m_strMusicFile, true);
}

void CSoundManager::playSound(const char* strFileName)
{
    if (!m_nSoundOn)
	{
		return;
	}
	CocosDenshion::SimpleAudioEngine::sharedEngine()->playEffect(strFileName);
}

void CSoundManager::pauseMusic()
{
    CocosDenshion::SimpleAudioEngine::sharedEngine()->pauseBackgroundMusic();
}

void CSoundManager::resumeMusic()
{
    CocosDenshion::SimpleAudioEngine::sharedEngine()->resumeBackgroundMusic();
}

void CSoundManager::stopMusic()
{
    CocosDenshion::SimpleAudioEngine::sharedEngine()->stopBackgroundMusic(false);
}


