#include "UtilFunc.h"
#include "cocos2d.h"
#include <jni.h>
#include <string>

USING_NS_CC;

extern bool g_bTestVersion;

unsigned long long getTime()
{
	timeval tv;
	gettimeofday(&tv, NULL);
	return (tv.tv_sec * 1000) + (tv.tv_usec / 1000);
}

int  GetTimeSecond()
{
	timeval tv;
	gettimeofday(&tv, NULL);
	return tv.tv_sec;
}

int	 getRand(int nMax)
{
	int nRand = CCRANDOM_0_1() * 1000000;
	return nRand % nMax;
}

void readGameData(int& nMaxLevel
				, int& nUnlockLevel, int& nUnlockIndex
				, int& nHeart, int& nTime, int& nCoin
				, int& nMusic, int& nSound, int& nNotify)
{
	nUnlockLevel = 1;
	nUnlockIndex = 0;
	nMusic = 1;
	nSound = 1;
	nNotify = 1;

    std::string strTargetFile = CCFileUtils::sharedFileUtils()->getWritablePath();
    strTargetFile.append("game.dmg");

    FILE * pFile = fopen( strTargetFile.c_str(), "rb" );
    if( pFile )
    {
    	char chTemp;
        int nLen = fread(&chTemp, sizeof(char), 1, pFile);
        nLen = fread(&nMaxLevel, sizeof(int), 1, pFile);
        nLen = fread(&nUnlockLevel, sizeof(int), 1, pFile);
        nLen = fread(&nUnlockIndex, sizeof(int), 1, pFile);
        nLen = fread(&nHeart, sizeof(int), 1, pFile);
        nLen = fread(&nTime, sizeof(int), 1, pFile);
        nLen = fread(&nCoin, sizeof(int), 1, pFile);
        nLen = fread(&nMusic, sizeof(int), 1, pFile);
        nLen = fread(&nSound, sizeof(int), 1, pFile);
        nLen = fread(&nNotify, sizeof(int), 1, pFile);
        fclose(pFile);
        pFile = NULL;
    }

//    nUnlockLevel = 20;

 //   if (g_bTestVersion)
 //   {
//    	nCoin = 200;
//    }
}

void writeGameData(int nMaxLevel, int nLevel, int nIndex
				, int nHeart, int nTime, int nCoin
				, int nMusic, int nSound, int nNotify)
{
    std::string strTargetFile = CCFileUtils::sharedFileUtils()->getWritablePath();
    strTargetFile.append("game.dmg");

    FILE * pFile = fopen( strTargetFile.c_str(), "wb" );
    if( pFile )
    {
    	char chTemp = 't';
        int nLen = fwrite(&chTemp, sizeof(char), 1, pFile);
        nLen = fwrite(&nMaxLevel, sizeof(int), 1, pFile);
        nLen = fwrite(&nLevel, sizeof(int), 1, pFile);
        nLen = fwrite(&nIndex, sizeof(int), 1, pFile);
        nLen = fwrite(&nHeart, sizeof(int), 1, pFile);
        nLen = fwrite(&nTime, sizeof(int), 1, pFile);
        nLen = fwrite(&nCoin, sizeof(int), 1, pFile);
        nLen = fwrite(&nMusic, sizeof(int), 1, pFile);
        nLen = fwrite(&nSound, sizeof(int), 1, pFile);
        nLen = fwrite(&nNotify, sizeof(int), 1, pFile);
        fclose(pFile);
        pFile = NULL;
    }
}

void getLevelRecordData(int nLevelMax, int& nLevelCnt, int* pnData)
{
    std::string strTargetFile = CCFileUtils::sharedFileUtils()->getWritablePath();
    strTargetFile.append("record.dmg");

    FILE * pFile = fopen( strTargetFile.c_str(), "rb" );
    if( pFile )
    {
    	nLevelCnt = fread(pnData, sizeof(int), nLevelMax, pFile);
        fclose(pFile);
        pFile = NULL;
    }
}

void setLevelRecordData(int nLevelMax, int* pnData)
{
    std::string strTargetFile = CCFileUtils::sharedFileUtils()->getWritablePath();
    strTargetFile.append("record.dmg");

    FILE * pFile = fopen( strTargetFile.c_str(), "wb" );
    if( pFile )
    {
        int nLen = fwrite(pnData, sizeof(int), nLevelMax, pFile);
        fclose(pFile);
        pFile = NULL;
    }
}

void getLevelStarData(int nLevelMax, int& nLevelCnt, int* pnData)
{
    std::string strTargetFile = CCFileUtils::sharedFileUtils()->getWritablePath();
    strTargetFile.append("star.dmg");

    FILE * pFile = fopen( strTargetFile.c_str(), "rb" );
    if( pFile )
    {
    	nLevelCnt = fread(pnData, sizeof(int), nLevelMax, pFile);
        fclose(pFile);
        pFile = NULL;
    }
}

void setLevelStarData(int nLevelMax, int* pnData)
{
    std::string strTargetFile = CCFileUtils::sharedFileUtils()->getWritablePath();
    strTargetFile.append("star.dmg");

    FILE * pFile = fopen( strTargetFile.c_str(), "wb" );
    if( pFile )
    {
        int nLen = fwrite(pnData, sizeof(int), nLevelMax, pFile);
        fclose(pFile);
        pFile = NULL;
    }
}

bool getLocalFileName(const char* strInFile, char* strOutFile)
{
    std::string strTargetFile = CCFileUtils::sharedFileUtils()->getWritablePath();
	strTargetFile.append(strInFile);
	strcpy(strOutFile, strTargetFile.c_str());
	return true;
}

bool getLocalFile(const char* strInFile, char* strOutFile)
{
    std::string strTargetFile = CCFileUtils::sharedFileUtils()->getWritablePath();
	strTargetFile.append(strInFile);

	FILE* pFile = fopen( strTargetFile.c_str(), "r" );
	if(pFile )
	{
		fclose(pFile);
	}
	else
	{
		std::string strSourceFile = CCFileUtils::sharedFileUtils()->fullPathForFilename(strInFile);

		unsigned long ulSize = 0;
		unsigned char* pBuffer = CCFileUtils::sharedFileUtils()->getFileData(strSourceFile.c_str(), "rb", &ulSize);
		if (!pBuffer)
		{
			CCLog("err get data from file: %s", strSourceFile.c_str());
			return false;
		}

		FILE* fp = fopen(strTargetFile.c_str(), "wb");
		if (!fp)
		{
			CCLog("err open file(wb): %s", strTargetFile.c_str());
			return false;
		}
		int nLen = fwrite(pBuffer, 1, ulSize, fp);

		delete[] pBuffer;
		fclose(fp);
		fp = NULL;

		if (nLen < ulSize)
		{
			CCLog("err: read: %u, write %d", ulSize, nLen);
			return false;
		}
	}

	strcpy(strOutFile, strTargetFile.c_str());
	return true;
}

extern "C"
{
	std::string parseJstring(JNIEnv* env, jobject thiz, jstring _data)
	{
		char* rtn = NULL;
		jclass clsstring = env->FindClass("java/lang/String");
		jstring strencode = env->NewStringUTF("utf-8");
		jmethodID mid = env->GetMethodID(clsstring, "getBytes", "(Ljava/lang/String;)[B");

		jbyteArray barr = (jbyteArray)env->CallObjectMethod(_data, mid, strencode);
		jsize alen = env->GetArrayLength(barr);
		jbyte* ba = env->GetByteArrayElements(barr, JNI_FALSE);
		if(alen > 0)
		{
			rtn = (char*)malloc(alen + 1);
			memcpy(rtn, ba, alen);
			rtn[alen] = 0;
		}
		env->ReleaseByteArrayElements(barr, ba, 0);
		std::string data(rtn);
		free(rtn);
		return data;
	}
}
