#include "baseSDKController.h"


#if (CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
    #include <jni.h>
    #include "platform/android/jni/JniHelper.h"
#endif
#include "GameData.h"
#include "GameModel.h"
//hashKey  facebook:   ZpHZlc1qxHBR2vBAB7BQrnInmYw=   
using namespace cocos2d;

extern bool g_bConnectServer;

#if (CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
extern "C"
{
	std::string parseJstring(JNIEnv* env, jobject thiz, jstring _data);

	void Java_org_cocos2dx_run_JellyCrash_NotifyGoodsInfoBase(JNIEnv* env,jobject thiz,jstring _orderId,jstring _goods)
	{
		std::string strOrderId = parseJstring(env, thiz, _orderId);
		std::string strGoods = parseJstring(env, thiz, _goods);

		CBaseSDKController::sharedInstance()->receiveGoods(strOrderId, strGoods);
	}
}
#endif
CBaseSDKController* CBaseSDKController::s_paySDKController = NULL;


CBaseSDKController::CBaseSDKController()
{

}

CBaseSDKController::~CBaseSDKController()
{
	if(s_paySDKController){
		delete s_paySDKController;
		s_paySDKController= NULL;
	}
}

CBaseSDKController* CBaseSDKController::sharedInstance()
{
    if (!s_paySDKController)
    {
    	s_paySDKController = new CBaseSDKController();
    }
    return s_paySDKController;
}

void CBaseSDKController::receiveGoods(string orderId, string strGoods)
{

#if (CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
	int nGoodIndex = atoi(orderId.c_str());
    
    
    std::vector<int> goldnumv =  CGameData::getInstance()->getBuyGoldNum();
    
	switch(nGoodIndex)
	{
		case 1:
			{
//				CCNotificationCenter::sharedNotificationCenter()->postNotification("buygoods1", CCString::create(strGoods));
                CGameData::getInstance()->gainGold(  goldnumv[0]);
			}
			break;
		case 2:
			{
//				CCNotificationCenter::sharedNotificationCenter()->postNotification("buygoods2", CCString::create(strGoods));
                CGameData::getInstance()->gainGold(  goldnumv[1]);
			}
			break;
		case 3:
			{
//				CCNotificationCenter::sharedNotificationCenter()->postNotification("buygoods3", CCString::create(strGoods));
                CGameData::getInstance()->gainGold(  goldnumv[2]);
			}
			break;
		case 1000://facebook back
			{
//				CCNotificationCenter::sharedNotificationCenter()->postNotification("facebookBack", CCString::create(strGoods));
               // GameModel::getInstance()->mission1ok();
                CGameData::getInstance()->gainGold(  2000);
			}
			break;
        case 2001:
            {
                CGameData::getInstance() -> strPrice1 = strGoods.c_str();
            }
            break;
        case 2002:
        {
            CGameData::getInstance() -> strPrice2 =strGoods.c_str();
        }
            break;
        case 2003:
        {
            CGameData::getInstance() -> strPrice3 = strGoods.c_str();
        }
            break;
		default:
			break;
	}

	if (g_bConnectServer)
	{
		/*
		string strUrl = "http://mushroom.dshmama.com/?m=pay&a=base&data={";
		strUrl += "\"imei\":\"";
		strUrl += g_pGameData->getIMEI();
		strUrl += "\",\"orderid\":\"";
		strUrl += orderId;
		strUrl += "\",\"ordertype\":\"1\"}"; // 0为测试状态 ，1为正式
		g_pHttpPost->send(strUrl.c_str(), this, callfuncND_selector(CBaseSDKController::onRequestCompleted));
		*/
	}
#endif
}

void CBaseSDKController::buy(int nIndex, char* strUserID)
{
	#if (CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
	{
		JniMethodInfo minfo;
		bool isHave = JniHelper::getStaticMethodInfo(minfo, "org/cocos2dx/run/JellyCrash", "payBase", "(Ljava/lang/String;)V");
		if (!isHave) {
		}else{
			stringstream cc;
			cc << nIndex;
			jstring StringArg = minfo.env->NewStringUTF(cc.str().c_str());
			minfo.env->CallStaticVoidMethod(minfo.classID, minfo.methodID, StringArg);
		}
	}
	#endif
}

bool CBaseSDKController::isMusicEnabled()
{
#if (CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID) //判断当前是否为Android平台
	{
		JniMethodInfo minfo;//定义Jni函数信息结构体
		//getStaticMethodInfo 次函数返回一个bool值表示是否找到此函数
		bool isHave = JniHelper::getStaticMethodInfo(minfo,"org/cocos2dx/run/JellyCrash","isMusicEnabled", "()Z");
		if (!isHave) {
		}else{

//			minfo.env->CallStaticVoidMethod(minfo.classID, minfo.methodID,StringArg);
			minfo.env->CallBooleanMethod (minfo.classID, minfo.methodID,NULL);
		}
		//	CCLog("jni-java函数执行完毕");
	}
#endif
}

void CBaseSDKController::quitGame()
{
#if (CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID) //判断当前是否为Android平台
	{
		JniMethodInfo minfo;//定义Jni函数信息结构体
		bool isHave = JniHelper::getStaticMethodInfo(minfo,"org/cocos2dx/run/JellyCrash","quitGame", "()V");
		if (isHave) {
			minfo.env->CallStaticVoidMethod (minfo.classID, minfo.methodID,NULL);
		}
	}
#endif
}

void CBaseSDKController::getMoreGames()
{
#if (CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID) //判断当前是否为Android平台
	{
		JniMethodInfo minfo;//定义Jni函数信息结构体
		bool isHave = JniHelper::getStaticMethodInfo(minfo,"org/cocos2dx/run/JellyCrash","getMoreGames", "()V");
		if (isHave) {
			minfo.env->CallStaticVoidMethod (minfo.classID, minfo.methodID,NULL);
		}
	}
#endif
}

void CBaseSDKController::onRequestCompleted(cocos2d::CCNode *sender, void *data)
{



}


void CBaseSDKController::openDownUCURL( )
{
#if (CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID) //判断当前是否为Android平台
	{
		JniMethodInfo minfo;//定义Jni函数信息结构体
		bool isHave = JniHelper::getStaticMethodInfo(minfo,"org/cocos2dx/run/JellyCrash","openDownUCURL", "()V");
    
		if (isHave) {
			minfo.env->CallStaticVoidMethod (minfo.classID, minfo.methodID,NULL);
		}
	}
#endif
}

void CBaseSDKController::alertMsg( char const * msg)
{
	//return;
#if (CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID) //判断当前是否为Android平台
	{
		JniMethodInfo minfo;//定义Jni函数信息结构体
		bool isHave = JniHelper::getStaticMethodInfo(minfo,"org/cocos2dx/run/JellyCrash","alertMsg", "(Ljava/lang/String;)V");
		if (isHave) {
			jstring jvtText = minfo.env->NewStringUTF(msg);
			minfo.env->CallStaticVoidMethod (minfo.classID, minfo.methodID,jvtText);
		}
	}
#endif
}

void CBaseSDKController::shareToFacebook( char const * msg)
{
	//return;
#if (CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID) //判断当前是否为Android平台
	{
		JniMethodInfo minfo;//定义Jni函数信息结构体
		bool isHave = JniHelper::getStaticMethodInfo(minfo,"org/cocos2dx/run/JellyCrash","shareFacebook", "(Ljava/lang/String;)V");
		CCLog("shareToFacebook isHave");
		if (isHave) {
            CCLog("shareToFacebook isHave true");
			jstring jvtText = minfo.env->NewStringUTF(msg);
			minfo.env->CallStaticVoidMethod (minfo.classID, minfo.methodID,jvtText);
		}
	}
#endif
}

void CBaseSDKController::start9gameAds()
{
#if (CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID) //判断当前是否为Android平台
	{
		JniMethodInfo minfo;//定义Jni函数信息结构体
		bool isHave = JniHelper::getStaticMethodInfo(minfo,"org/cocos2dx/run/JellyCrash","start9gameAds", "()V");
		CCLog("shareToFacebook isHave");
		if (isHave) {
		CCLog("shareToFacebook isHave true");
			minfo.env->CallStaticVoidMethod (minfo.classID, minfo.methodID,NULL);
		}
	}
#endif
}
void CBaseSDKController::over9gameAds()
{
#if (CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID) //判断当前是否为Android平台
	{
		JniMethodInfo minfo;//定义Jni函数信息结构体
		bool isHave = JniHelper::getStaticMethodInfo(minfo,"org/cocos2dx/run/JellyCrash","over9gameAds", "()V");
		CCLog("shareToFacebook isHave");
		if (isHave) {
		CCLog("shareToFacebook isHave true");
			minfo.env->CallStaticVoidMethod (minfo.classID, minfo.methodID,NULL);
		}
	}
#endif
}




void CBaseSDKController::umSendEvent(const char * eventid , const char * evtText)
{
    // [MobClick event:[NSString stringWithUTF8String:eventid] label:[NSString stringWithUTF8String:evtText]];
#if (CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID) //判断当前是否为Android平台
	
    JniMethodInfo minfo;//定义Jni函数信息结构体
    //getStaticMethodInfo 次函数返回一个bool值表示是否找到此函数
    bool isHave = JniHelper::getStaticMethodInfo(minfo,"org/cocos2dx/run/JellyCrash","umengEvent", "(Ljava/lang/String;Ljava/lang/String;)V");
    
    if (!isHave) {
        CCLog("umengEvent:此函数不存在");
    }else{
        CCLog("umengEvent:此函数存在");
        //调用此函数
        
        jstring jeventid = minfo.env->NewStringUTF(eventid);
        jstring jevtText = minfo.env->NewStringUTF(evtText);
        minfo.env->CallStaticVoidMethod(minfo.classID, minfo.methodID , jeventid , jevtText);
    }
	
    CCLog("_umengEvent-java函数执行完毕");
#endif
	
}


